' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Imports System.Threading
Imports SocketTools.SocketWrench.ErrorCode

Public Class ServerForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents LocalAddress As System.Windows.Forms.ComboBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents LocalPort As System.Windows.Forms.TextBox
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents MaxClients As System.Windows.Forms.TextBox
    Friend WithEvents ListenButton As System.Windows.Forms.Button
    Friend WithEvents DisconnectButton As System.Windows.Forms.Button
    Friend WithEvents Output As System.Windows.Forms.TextBox
    Friend WithEvents ServerStatus As System.Windows.Forms.StatusBar

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.Label1 = New System.Windows.Forms.Label
Me.LocalAddress = New System.Windows.Forms.ComboBox
Me.Label2 = New System.Windows.Forms.Label
Me.LocalPort = New System.Windows.Forms.TextBox
Me.Label3 = New System.Windows.Forms.Label
Me.MaxClients = New System.Windows.Forms.TextBox
Me.ListenButton = New System.Windows.Forms.Button
Me.DisconnectButton = New System.Windows.Forms.Button
Me.Output = New System.Windows.Forms.TextBox
Me.ServerStatus = New System.Windows.Forms.StatusBar
Me.SuspendLayout()
'
'Label1
'
Me.Label1.Location = New System.Drawing.Point(15, 18)
Me.Label1.Name = "Label1"
Me.Label1.Size = New System.Drawing.Size(49, 15)
Me.Label1.TabIndex = 0
Me.Label1.Text = "Address:"
'
'LocalAddress
'
Me.LocalAddress.Location = New System.Drawing.Point(64, 15)
Me.LocalAddress.Name = "LocalAddress"
Me.LocalAddress.Size = New System.Drawing.Size(164, 21)
Me.LocalAddress.TabIndex = 1
'
'Label2
'
Me.Label2.Location = New System.Drawing.Point(245, 18)
Me.Label2.Name = "Label2"
Me.Label2.Size = New System.Drawing.Size(29, 15)
Me.Label2.TabIndex = 2
Me.Label2.Text = "Port:"
'
'LocalPort
'
Me.LocalPort.Location = New System.Drawing.Point(279, 15)
Me.LocalPort.Name = "LocalPort"
Me.LocalPort.Size = New System.Drawing.Size(38, 20)
Me.LocalPort.TabIndex = 3
Me.LocalPort.Text = ""
'
'Label3
'
Me.Label3.Location = New System.Drawing.Point(333, 18)
Me.Label3.Name = "Label3"
Me.Label3.Size = New System.Drawing.Size(44, 15)
Me.Label3.TabIndex = 4
Me.Label3.Text = "Clients:"
'
'MaxClients
'
Me.MaxClients.Location = New System.Drawing.Point(378, 15)
Me.MaxClients.Name = "MaxClients"
Me.MaxClients.Size = New System.Drawing.Size(38, 20)
Me.MaxClients.TabIndex = 5
Me.MaxClients.Text = ""
'
'ListenButton
'
Me.ListenButton.Location = New System.Drawing.Point(135, 259)
Me.ListenButton.Name = "ListenButton"
Me.ListenButton.Size = New System.Drawing.Size(79, 27)
Me.ListenButton.TabIndex = 7
Me.ListenButton.Text = "Listen"
'
'DisconnectButton
'
Me.DisconnectButton.Location = New System.Drawing.Point(240, 259)
Me.DisconnectButton.Name = "DisconnectButton"
Me.DisconnectButton.Size = New System.Drawing.Size(79, 27)
Me.DisconnectButton.TabIndex = 8
Me.DisconnectButton.Text = "Disconnect"
'
'Output
'
Me.Output.BackColor = System.Drawing.Color.White
Me.Output.Location = New System.Drawing.Point(9, 50)
Me.Output.MaxLength = 0
Me.Output.Multiline = True
Me.Output.Name = "Output"
Me.Output.ReadOnly = True
Me.Output.ScrollBars = System.Windows.Forms.ScrollBars.Both
Me.Output.Size = New System.Drawing.Size(435, 201)
Me.Output.TabIndex = 9
Me.Output.Text = ""
Me.Output.WordWrap = False
'
'ServerStatus
'
Me.ServerStatus.Location = New System.Drawing.Point(0, 295)
Me.ServerStatus.Name = "ServerStatus"
Me.ServerStatus.Size = New System.Drawing.Size(454, 22)
Me.ServerStatus.SizingGrip = False
Me.ServerStatus.TabIndex = 10
'
'ServerForm
'
Me.AcceptButton = Me.ListenButton
Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
Me.BackColor = System.Drawing.SystemColors.Control
Me.ClientSize = New System.Drawing.Size(454, 317)
Me.Controls.Add(Me.ServerStatus)
Me.Controls.Add(Me.Output)
Me.Controls.Add(Me.DisconnectButton)
Me.Controls.Add(Me.ListenButton)
Me.Controls.Add(Me.MaxClients)
Me.Controls.Add(Me.Label3)
Me.Controls.Add(Me.LocalPort)
Me.Controls.Add(Me.Label2)
Me.Controls.Add(Me.LocalAddress)
Me.Controls.Add(Me.Label1)
Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
Me.MaximizeBox = False
Me.Name = "ServerForm"
Me.Text = "Echo Server"
Me.ResumeLayout(False)

    End Sub

#End Region

    Private Structure SessionInfo
        Dim Session As SessionClass
        Dim Thread As Threading.Thread
    End Structure

    Private WithEvents Socket As SocketTools.SocketWrench
    Private Client(0) As SessionInfo
    Private LastClient As Integer
    Private ActiveClients As Integer

    <STAThread()> Public Shared Sub Main(ByVal CmdArgs() As String)
        Application.Run(New ServerForm)
    End Sub

    Public Sub WriteLine(ByVal Line As String)
        Output.AppendText(Line & vbCrLf)
    End Sub

    Public Function RegisterClient(ByRef Session As SessionClass, ByRef Thread As Threading.Thread) As Boolean
        Dim nIndex As Integer
        Dim nMaxClients As Integer

        RegisterClient = False

        nMaxClients = Val(MaxClients.Text)
        If nMaxClients > 0 And ActiveClients >= nMaxClients Then
            Exit Function
        End If

        Monitor.Enter(Client)

        For nIndex = 0 To LastClient - 1
            If Client(nIndex).Session Is Nothing Then
                Client(nIndex).Session = Session
                Client(nIndex).Thread = Thread
                ActiveClients = ActiveClients + 1
                RegisterClient = True
                ServerStatus.Text = CStr(ActiveClients) & " clients connected to server"
                Monitor.Exit(Client)
                Exit Function
            End If
        Next

        ReDim Preserve Client(LastClient)
        Client(LastClient).Session = Session
        Client(LastClient).Thread = Thread

        LastClient = LastClient + 1
        ActiveClients = ActiveClients + 1
        RegisterClient = True
        ServerStatus.Text = CStr(ActiveClients) & " clients connected to server"
        Monitor.Exit(Client)
    End Function

    Public Function UnregisterClient(ByRef Session As SessionClass) As Boolean
        Dim nIndex As Integer

        UnregisterClient = False
        If ActiveClients = 0 Or Session Is Nothing Then Exit Function

        Monitor.Enter(Client)

        For nIndex = 0 To LastClient - 1
            If Client(nIndex).Session Is Session Then
                Client(nIndex).Session = Nothing
                Client(nIndex).Thread = Nothing
                ActiveClients = ActiveClients - 1
                ServerStatus.Text = CStr(ActiveClients) & " clients connected to server"
                UnregisterClient = True
                Exit For
            End If
        Next

        Monitor.Exit(Client)
    End Function

    Public Sub TerminateClients()
        Dim nIndex As Integer

        Monitor.Enter(Client)
        For nIndex = 0 To LastClient - 1
            If Not Client(nIndex).Session Is Nothing Then
                Client(nIndex).Session.Terminate()
            End If
        Next
        Monitor.Exit(Client)

        For nIndex = 0 To LastClient - 1
            If Not Client(nIndex).Session Is Nothing Then
                Client(nIndex).Thread.Join()
            End If
        Next
    End Sub

    Private Sub ServerForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim nIndex As Integer

        ' Create an instance of the SocketWrench class which will
        ' function as our listening (server) socket
        Socket = New SocketTools.SocketWrench

        If Not Socket.IsInitialized Then
            Throw New System.Exception("Unable to initialize SocketWrench class")
        End If

        ' Initialize the LocalAddress control with the default
        ' addresses the socket can be bound to
        LocalAddress.Items.Clear()
        LocalAddress.Items.Add("<Any Address>")
        LocalAddress.Items.Add("127.0.0.1")

        ' Add the address for each interface configured on the
        ' local system
        For nIndex = 0 To Socket.AdapterCount - 1
            LocalAddress.Items.Add(Socket.AdapterAddress(nIndex))
        Next

        ' Set the default value to listen on any local address
        LocalAddress.SelectedIndex = 0

        ' Set the default local port to the echo service
        LocalPort.Text = "7"

        ' Set the default maximum number of clients
        MaxClients.Text = "100"

        ' Update the form buttons and status bar
        ServerStatus.Text = CStr(ActiveClients) & " clients connected to server"
    End Sub

    Private Sub ServerForm_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        If Socket.IsListening Then
            Socket.Disconnect()
        End If
        TerminateClients()
    End Sub

    Private Sub ListenButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListenButton.Click
        If Socket.IsListening Then
            Socket.Disconnect()
            ListenButton.Text = "Listen"
        Else
            Dim strLocalAddress As String
            Dim nLocalPort As Integer

            strLocalAddress = LocalAddress.Text.Trim()
            If Len(strLocalAddress) = 0 Or strLocalAddress = "<Any Address>" Then
                strLocalAddress = "0.0.0.0" ' Listen on all available interfaces
            End If

            nLocalPort = Val(LocalPort.Text)
            If nLocalPort < 1 Or nLocalPort > 65535 Then
                MsgBox("Please specify a valid local port number", MsgBoxStyle.Exclamation)
                LocalPort.Focus()
                Exit Sub
            End If

            Socket.Blocking = False

            If Not Socket.Listen(strLocalAddress, nLocalPort) Then
                If Socket.LastError = errorAccessDenied Then
                    MsgBox("This local port is currently being used by another program." & vbCrLf & _
                           "Try specifying an alternate port number for this server.", MsgBoxStyle.Information)
                Else
                    MsgBox(Socket.LastErrorString, MsgBoxStyle.Exclamation)
                End If
                Exit Sub
            End If
            ListenButton.Text = "Pause"
        End If
    End Sub

    Private Sub Socket_OnAccept(ByVal sender As Object, ByVal e As SocketTools.SocketWrench.AcceptEventArgs) Handles Socket.OnAccept
        Dim oSession As SessionClass
        Dim oThread As Threading.Thread
        Static nSession As Long

        Debug.WriteLine("OnAccept Handle=" & e.Handle)
        nSession = nSession + 1

        oSession = New SessionClass
        oSession.Server = Me
        oSession.Handle = e.Handle

        oThread = New Threading.Thread(AddressOf oSession.ThreadMain)
        oThread.ApartmentState = ApartmentState.STA
        oThread.Name = "Session" & CLng(nSession)
        oThread.Start()
    End Sub

    Private Sub DisconnectButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DisconnectButton.Click
        If ActiveClients = 0 Then
            MsgBox("There are currently no clients connected to the server", MsgBoxStyle.Information)
            Exit Sub
        Else
            If MsgBox("Are you sure you want to disconnect all clients?", MsgBoxStyle.YesNo) <> MsgBoxResult.Yes Then
                Exit Sub
            End If
        End If

        TerminateClients()
        WriteLine("All active client sessions terminated")
    End Sub

End Class
