' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Imports System.Threading
Imports SocketTools.SocketWrench.ErrorCode
Imports SocketTools.SocketWrench.SocketOptions

Public Class SessionClass
    Public Server As ServerForm
    Public Socket As SocketTools.SocketWrench
    Public Handle As Integer
    Private Terminated As Boolean

    Public Sub ThreadMain()
        Dim nThreadId As Integer
        Dim strThreadName As String
        Dim strBuffer As String
        Dim nResult As Integer

        nThreadId = Thread.GetDomain().GetCurrentThreadId()
        strThreadName = "Thread " & Hex(nThreadId) & " (" & Thread.CurrentThread.Name & ")"

        ' Create an instance of the class
        Socket = New SocketTools.SocketWrench
        Socket.Initialize()

        ' Specify the server certificate to use
        Socket.CertificateStore = "MY"
        Socket.CertificateName = "localhost"

        If Not Socket.Accept(Handle, 10, optionSecure) Then
            Server.WriteLine(strThreadName & " unable to accept connection, error " & Socket.LastError)
            Exit Sub
        End If

        If Server.RegisterClient(Me, Thread.CurrentThread()) = False Then
            Socket.Disconnect()
            Server.WriteLine(strThreadName & " unable to accept connection, too many active clients")
            Exit Sub
        End If

        Server.WriteLine(strThreadName & " accepted connection from " & Socket.PeerAddress)

        Do While Not Terminated
            If Socket.IsReadable Then
                nResult = Socket.Read(strBuffer, 1024)
                If nResult = 0 Then
                    Server.WriteLine(strThreadName & " connection closed by client")
                    Exit Do
                ElseIf nResult = -1 Then
                    Server.WriteLine(strThreadName & " socket read failed, error " & Socket.LastError)
                End If

                nResult = Socket.Write(strBuffer, nResult)
                If nResult = -1 Then
                    Server.WriteLine(strThreadName & " socket write failed, error " & Socket.LastError)
                    Exit Do
                End If
            End If
        Loop

        Socket.Disconnect()
        Server.UnregisterClient(Me)
        Exit Sub
    End Sub

    Public Sub Terminate()
        Terminated = True
    End Sub

End Class
