// SocketWrench 10
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using System.Threading; 

namespace EchoServer
{
    public class ServerForm : System.Windows.Forms.Form 
    { 
        
        #region '" Windows Form Designer generated code "' 
        
        public ServerForm() : base() 
        { 
            
            
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
            
            // Add any initialization after the InitializeComponent() call
            
        } 
        
        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool disposing ) 
        { 
            if ( disposing ) 
            { 
                if ( !( ( components == null ) ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( disposing ); 
        } 
        
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.  
        // Do not modify it using the code editor.
        internal System.Windows.Forms.Label Label1; 
        internal System.Windows.Forms.ComboBox LocalAddress; 
        internal System.Windows.Forms.Label Label2; 
        internal System.Windows.Forms.TextBox LocalPort; 
        internal System.Windows.Forms.Label Label3; 
        internal System.Windows.Forms.TextBox MaxClients; 
        internal System.Windows.Forms.Button ListenButton; 
        internal System.Windows.Forms.Button DisconnectButton; 
        internal System.Windows.Forms.TextBox Output; 
        internal System.Windows.Forms.StatusBar ServerStatus; 
        
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.Label1 = new System.Windows.Forms.Label(); 
            this.LocalAddress = new System.Windows.Forms.ComboBox(); 
            this.Label2 = new System.Windows.Forms.Label(); 
            this.LocalPort = new System.Windows.Forms.TextBox(); 
            this.Label3 = new System.Windows.Forms.Label(); 
            this.MaxClients = new System.Windows.Forms.TextBox(); 
            this.ListenButton = new System.Windows.Forms.Button(); 
            this.DisconnectButton = new System.Windows.Forms.Button(); 
            this.Output = new System.Windows.Forms.TextBox(); 
            this.ServerStatus = new System.Windows.Forms.StatusBar(); 
            this.SuspendLayout(); 
            // 
            // Label1
            // 
            this.Label1.Location = new System.Drawing.Point( 15, 18 ); 
            this.Label1.Name = "Label1"; 
            this.Label1.Size = new System.Drawing.Size( 49, 15 ); 
            this.Label1.TabIndex = 0; 
            this.Label1.Text = "Address:"; 
            // 
            // LocalAddress
            // 
            this.LocalAddress.Location = new System.Drawing.Point( 64, 15 ); 
            this.LocalAddress.Name = "LocalAddress"; 
            this.LocalAddress.Size = new System.Drawing.Size( 164, 21 ); 
            this.LocalAddress.TabIndex = 1; 
            // 
            // Label2
            // 
            this.Label2.Location = new System.Drawing.Point( 245, 18 ); 
            this.Label2.Name = "Label2"; 
            this.Label2.Size = new System.Drawing.Size( 29, 15 ); 
            this.Label2.TabIndex = 2; 
            this.Label2.Text = "Port:"; 
            // 
            // LocalPort
            // 
            this.LocalPort.Location = new System.Drawing.Point( 279, 15 ); 
            this.LocalPort.Name = "LocalPort"; 
            this.LocalPort.Size = new System.Drawing.Size( 38, 20 ); 
            this.LocalPort.TabIndex = 3; 
            this.LocalPort.Text = ""; 
            // 
            // Label3
            // 
            this.Label3.Location = new System.Drawing.Point( 333, 18 ); 
            this.Label3.Name = "Label3"; 
            this.Label3.Size = new System.Drawing.Size( 44, 15 ); 
            this.Label3.TabIndex = 4; 
            this.Label3.Text = "Clients:"; 
            // 
            // MaxClients
            // 
            this.MaxClients.Location = new System.Drawing.Point( 378, 15 ); 
            this.MaxClients.Name = "MaxClients"; 
            this.MaxClients.Size = new System.Drawing.Size( 38, 20 ); 
            this.MaxClients.TabIndex = 5; 
            this.MaxClients.Text = ""; 
            // 
            // ListenButton
            // 
            this.ListenButton.Location = new System.Drawing.Point( 135, 259 ); 
            this.ListenButton.Name = "ListenButton"; 
            this.ListenButton.Size = new System.Drawing.Size( 79, 27 ); 
            this.ListenButton.TabIndex = 7; 
            this.ListenButton.Text = "Listen"; 
            // 
            // DisconnectButton
            // 
            this.DisconnectButton.Location = new System.Drawing.Point( 240, 259 ); 
            this.DisconnectButton.Name = "DisconnectButton"; 
            this.DisconnectButton.Size = new System.Drawing.Size( 79, 27 ); 
            this.DisconnectButton.TabIndex = 8; 
            this.DisconnectButton.Text = "Disconnect"; 
            // 
            // Output
            // 
            this.Output.BackColor = System.Drawing.Color.White; 
            this.Output.Location = new System.Drawing.Point( 9, 50 ); 
            this.Output.MaxLength = 0; 
            this.Output.Multiline = true; 
            this.Output.Name = "Output"; 
            this.Output.ReadOnly = true; 
            this.Output.ScrollBars = System.Windows.Forms.ScrollBars.Both; 
            this.Output.Size = new System.Drawing.Size( 435, 201 ); 
            this.Output.TabIndex = 9; 
            this.Output.Text = ""; 
            this.Output.WordWrap = false; 
            // 
            // ServerStatus
            // 
            this.ServerStatus.Location = new System.Drawing.Point( 0, 295 ); 
            this.ServerStatus.Name = "ServerStatus"; 
            this.ServerStatus.Size = new System.Drawing.Size( 454, 22 ); 
            this.ServerStatus.SizingGrip = false; 
            this.ServerStatus.TabIndex = 10; 
            // 
            // ServerForm
            // 
            this.AcceptButton = this.ListenButton; 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 ); 
            this.BackColor = System.Drawing.SystemColors.Control; 
            this.ClientSize = new System.Drawing.Size( 454, 317 ); 
            this.Controls.Add( this.ServerStatus ); 
            this.Controls.Add( this.Output ); 
            this.Controls.Add( this.DisconnectButton ); 
            this.Controls.Add( this.ListenButton ); 
            this.Controls.Add( this.MaxClients ); 
            this.Controls.Add( this.Label3 ); 
            this.Controls.Add( this.LocalPort ); 
            this.Controls.Add( this.Label2 ); 
            this.Controls.Add( this.LocalAddress ); 
            this.Controls.Add( this.Label1 ); 
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog; 
            this.MaximizeBox = false; 
            this.Name = "ServerForm"; 
            this.Text = "Echo Server"; 
            this.ResumeLayout( false ); 
            
            // events handled by ServerForm_Load
            base.Load += new System.EventHandler( ServerForm_Load ); 
            // events handled by ServerForm_Closed
            base.Closed += new System.EventHandler( ServerForm_Closed ); 
            // events handled by ListenButton_Click
            ListenButton.Click += new System.EventHandler( ListenButton_Click ); 
            // events handled by DisconnectButton_Click
            DisconnectButton.Click += new System.EventHandler( DisconnectButton_Click ); 
        } 
        
		[ STAThread() ]
		public static void Main( string[] CmdArgs ) 
		{ 
			Application.Run( new ServerForm() ); 
		} 
		#endregion 
        
        private struct SessionInfo 
        { 
            public SessionClass Session; 
            public System.Threading.Thread Thread; 
        } 
        
        private SocketTools.SocketWrench Socket; 
        private SessionInfo[] Client = new SessionInfo[ 1 ]; 
        private int LastClient = 0; 
        private int ActiveClients = 0; 
		private int LastSessionId = 0;
        
        public void WriteLine( string Line ) 
        { 
            Output.AppendText( Line + "\r\n" ); 
        } 
        
        public bool RegisterClient( SessionClass Session, System.Threading.Thread Thread ) 
        { 
            int nIndex = 0; 
            int nMaxClients = 0; 
            
            nMaxClients = Int32.Parse( MaxClients.Text ); 
            if ( nMaxClients > 0 & ActiveClients >= nMaxClients ) 
            { 
                return false;
            } 
            
            Monitor.Enter( Client ); 
            
            for ( nIndex=0; nIndex < LastClient; nIndex++ ) 
            { 
                if ( Client[ nIndex ].Session == null ) 
                { 
                    Client[ nIndex ].Session = Session; 
                    Client[ nIndex ].Thread = Thread; 
                    ActiveClients = ActiveClients + 1; 
                    ServerStatus.Text = System.Convert.ToString( ActiveClients ) + " clients connected to server"; 
                    Monitor.Exit( Client ); 
                    return true; 
                } 
            } 
            
            SessionInfo[] NewClient = new SessionInfo[ LastClient + 1 ]; 
            System.Array.Copy( Client, NewClient, Math.Min( Client.Length, NewClient.Length ) ); 
            Client = NewClient; 
            Client[ LastClient ].Session = Session; 
            Client[ LastClient ].Thread = Thread; 
            
			LastClient++; 
			ActiveClients++; 
            
            ServerStatus.Text = System.Convert.ToString( ActiveClients ) + " clients connected to server"; 
            Monitor.Exit( Client ); 
            return true;
        } 
        
        public bool UnregisterClient( SessionClass Session ) 
        { 
            int nIndex = 0; 
            bool bResult = false;
            
            if ( ActiveClients == 0 | Session == null )
				return false;
            
            Monitor.Enter( Client ); 
            
            for ( nIndex=0; nIndex < LastClient; nIndex++ ) 
            { 
                if ( Client[ nIndex ].Session == Session ) 
                { 
                    Client[ nIndex ].Session = null; 
                    Client[ nIndex ].Thread = null; 
                    ActiveClients = ActiveClients - 1; 
                    ServerStatus.Text = ActiveClients.ToString() + " clients connected to server"; 
                    bResult = true; 
                    break;
                } 
            } 
            
            Monitor.Exit( Client ); 
            return bResult;
        } 
        
        public void TerminateClients() 
        { 
            int nIndex = 0; 
            
            Monitor.Enter( Client ); 
            for ( nIndex=0; nIndex < LastClient; nIndex++ ) 
            { 
                if (Client[ nIndex ].Session != null ) 
                { 
                    Client[ nIndex ].Session.Terminate(); 
                } 
            } 
            Monitor.Exit( Client ); 
            
            for ( nIndex=0; nIndex < LastClient; nIndex++ ) 
            { 
                if ( Client[ nIndex ].Session != null )
                { 
                    Client[ nIndex ].Thread.Join(); 
                } 
            } 
        } 
        
        private void ServerForm_Load( System.Object sender, System.EventArgs e ) 
        { 
            int nIndex = 0; 
            
            //  Create an instance of the SocketWrench class which will
            //  function as our listening (server) socket
            Socket = new SocketTools.SocketWrench(); 
            
            if (! Socket.IsInitialized ) 
            { 
                throw new System.Exception( "Unable to initialize SocketWrench class" ); 
            } 

			// Event handler for the OnAccept event
			Socket.OnAccept += new SocketTools.SocketWrench.OnAcceptEventHandler( Socket_OnAccept ); 
            
            //  Initialize the LocalAddress control with the default
            //  addresses the socket can be bound to
            LocalAddress.Items.Clear(); 
            LocalAddress.Items.Add( "<Any Address>" ); 
            LocalAddress.Items.Add( "127.0.0.1" ); 
            
            //  Add the address for each interface configured on the
            //  local system
            for ( nIndex=0; nIndex<=Socket.AdapterCount - 1; nIndex++ ) 
            { 
                LocalAddress.Items.Add( Socket.AdapterAddress[ nIndex ] ); 
            } 
            
            //  Set the default value to listen on any local address
            LocalAddress.SelectedIndex = 0; 
            
            //  Set the default local port to the echo service
            LocalPort.Text = "7"; 
            
            //  Set the default maximum number of clients
            MaxClients.Text = "100"; 
            
            //  Update the form buttons and status bar
            ServerStatus.Text = System.Convert.ToString( ActiveClients ) + " clients connected to server"; 
        } 
        
        private void ServerForm_Closed( object sender, System.EventArgs e ) 
        { 
            if ( Socket.IsListening ) 
            { 
                Socket.Disconnect(); 
            } 
            TerminateClients(); 
        } 

        private void ListenButton_Click( System.Object sender, System.EventArgs e ) 
        { 
            if ( Socket.IsListening ) 
            { 
                Socket.Disconnect(); 
                ListenButton.Text = "Listen"; 
            } 
            else 
            { 
                string strLocalAddress = null; 
                int nLocalPort = 0; 
                
                strLocalAddress = LocalAddress.Text.Trim(); 
                if (  strLocalAddress.Length == 0 | strLocalAddress == "<Any Address>" ) 
                { 
                    strLocalAddress = "0.0.0.0"; //  Listen on all available interfaces
                } 
                
                nLocalPort = Int32.Parse( LocalPort.Text ); 
                if ( nLocalPort < 1 | nLocalPort > 65535 ) 
                { 
                    MessageBox.Show( "Please specify a valid local port number", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); 
                    LocalPort.Focus(); 
                    return; 
                } 
                
                Socket.Blocking = false; 
                
                if (! Socket.Listen( strLocalAddress, nLocalPort )) 
                { 
                    if ( Socket.LastError == SocketTools.SocketWrench.ErrorCode.errorAccessDenied ) 
                    { 
                        MessageBox.Show( "This local port is currently being used by another program." + "\r\n" +
										 "Try specifying an alternate port number for this server.", "Error",
										 MessageBoxButtons.OK, MessageBoxIcon.Exclamation ); 
                    } 
                    else 
                    { 
                        MessageBox.Show( Socket.LastErrorString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
                    } 
                    return; 
                } 
                ListenButton.Text = "Pause"; 
            } 
        } 
        
        private void Socket_OnAccept( object sender, SocketTools.SocketWrench.AcceptEventArgs e ) 
        { 
            SessionClass oSession = null; 
            System.Threading.Thread oThread = null; 
            
            LastSessionId++;
            
            oSession = new SessionClass(); 
            oSession.Server = this; 
            oSession.Handle = e.Handle; 
            
            oThread = new System.Threading.Thread( new System.Threading.ThreadStart( oSession.ThreadMain ) ); 
            oThread.ApartmentState = ApartmentState.STA; 
            oThread.Name = "Session" + LastSessionId; 
            oThread.Start(); 
        } 
        
        private void DisconnectButton_Click( object sender, System.EventArgs e ) 
        { 
            if ( ActiveClients == 0 ) 
            { 
                MessageBox.Show( "There are currently no clients connected to the server", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation ); 
                return; 
            } 
            else 
            { 
                if ( MessageBox.Show( "Are you sure you want to disconnect all clients?", "Disconnect",
									  MessageBoxButtons.YesNo, MessageBoxIcon.Question ) != DialogResult.Yes ) 
                { 
                    return; 
                } 
            } 
            
            TerminateClients(); 
            WriteLine( "All active client sessions terminated" ); 
        } 
    } 
} 
