// SocketWrench 10
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;

using Protocol = SocketTools.SocketWrench.SocketProtocol;
using Options = SocketTools.SocketWrench.SocketOptions;

namespace QueryIP
{
    internal class formMain : System.Windows.Forms.Form 
    { 
        #region '"Windows Form Designer generated code "' 
        public formMain() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 
        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.Button Command1; 
        public System.Windows.Forms.Label Label2; 
        public System.Windows.Forms.Label Label1; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container(); 
            this.ToolTip1 = new System.Windows.Forms.ToolTip( this.components ); 
            this.Command1 = new System.Windows.Forms.Button(); 
            this.Label2 = new System.Windows.Forms.Label(); 
            this.Label1 = new System.Windows.Forms.Label(); 
            this.SuspendLayout(); 
            // 
            // Command1
            // 
            this.Command1.BackColor = System.Drawing.SystemColors.Control; 
            this.Command1.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Command1.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Command1.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Command1.Location = new System.Drawing.Point( 99, 112 ); 
            this.Command1.Name = "Command1"; 
            this.Command1.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Command1.Size = new System.Drawing.Size( 81, 29 ); 
            this.Command1.TabIndex = 0; 
            this.Command1.Text = "Query"; 
            // 
            // Label2
            // 
            this.Label2.BackColor = System.Drawing.SystemColors.Control; 
            this.Label2.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label2.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label2.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label2.Location = new System.Drawing.Point( 8, 64 ); 
            this.Label2.Name = "Label2"; 
            this.Label2.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label2.Size = new System.Drawing.Size( 269, 33 ); 
            this.Label2.TabIndex = 2; 
            this.Label2.Text = "You should be running the ServerIP example program, which will respond to this br" + "oadcast."; 
            // 
            // Label1
            // 
            this.Label1.BackColor = System.Drawing.SystemColors.Control; 
            this.Label1.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label1.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label1.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label1.Location = new System.Drawing.Point( 8, 12 ); 
            this.Label1.Name = "Label1"; 
            this.Label1.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label1.Size = new System.Drawing.Size( 270, 45 ); 
            this.Label1.TabIndex = 1; 
            // 
            // formMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 ); 
            this.BackColor = System.Drawing.SystemColors.Control; 
            this.ClientSize = new System.Drawing.Size( 289, 152 ); 
            this.Controls.Add( this.Command1 ); 
            this.Controls.Add( this.Label2 ); 
            this.Controls.Add( this.Label1 ); 
            this.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog; 
            this.Location = new System.Drawing.Point( 3, 29 ); 
            this.MaximizeBox = false; 
            this.MinimizeBox = false; 
            this.Name = "formMain"; 
            this.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen; 
            this.Text = "QueryIP"; 
            this.ResumeLayout( false ); 
            
            // events handled by Command1_Click
            Command1.Click += new System.EventHandler( Command1_Click ); 
            // events handled by formMain_Load
            base.Load += new System.EventHandler( formMain_Load ); 
        } 
        
		[STAThread]
		public static void Main()
		{
			Application.Run( new formMain() );
		}
		#endregion 
        
        private SocketTools.SocketWrench Socket = new SocketTools.SocketWrench(); 
        // 
        //  Configuration values for the UDP client
        // 
        private const string queryBroadcast = "255.255.255.255"; //  Local broadcast address
        private const short queryPort = 8195; //  Port number
        private const short queryTimeout = 5; //  Timeout period (seconds)
        private const short queryResponse = 128; //  Maximum datagram size
        
        private void Command1_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strAddress = null; 
            int nPort = 0; 
            
            Command1.Enabled = false; 
            
            if ( GetServerAddress( ref strAddress, ref nPort ) ) 
            { 
                MessageBox.Show( "The server requests that you connect to address" + "\r\n" + 
								 strAddress + " on port " + nPort, "Success",
								 MessageBoxButtons.OK, MessageBoxIcon.Information );
            } 
            else 
            { 
                MessageBox.Show( "Unable to determine server address", "Error",
								 MessageBoxButtons.OK, MessageBoxIcon.Exclamation ); 
            } 
            
            Command1.Enabled = true; 
        } 
        
        
        private bool GetServerAddress( ref string strAddress, ref int nPort ) 
        { 
            string strBuffer = null; 
            int nResult = 0; 
            int nIndex = 0; 

            //  Create a UDP socket and specify a broadcast IP address;
            //  note that the Connect method doesn't actually create a
            //  connection like it does with TCP, it simply creates the
            //  socket and sets the default address and port number
            
            if (! Socket.Connect( queryBroadcast, queryPort, Protocol.socketDatagram, queryTimeout, Options.optionBroadcast ) )
                return false; 
            
            //  Create a small datagram that just contains our local IP
            //  address and broadcast it over our local network
            
            strBuffer = Socket.LocalAddress; 
            if ( Socket.Write( strBuffer ) == -1 )
				return false;
            
            strBuffer = ""; 
            if ( Socket.Read( ref strBuffer, queryResponse ) == -1 )
				return false;
            
            //  The response from the server should be a string in the
            //  form of aaa.bbb.ccc.ddd:nnnn specifying both the IP
            //  address in dot-notation and the port number to connect to
            
            nIndex =  strBuffer.IndexOf( ":" );
            if ( nIndex == -1 )
				return false;
            
            //  Extract the IP address from the response and make sure
            //  that it looks like a valid address
            
            strAddress = strBuffer.Substring( 0, nIndex ); 

            if (! ValidAddress( ref strAddress ))
				return false; //  Malformed address
            
            //  Extract the port number from the response and make sure
            //  that it's a valid port number
            
            nPort = Int32.Parse( strBuffer.Substring( nIndex + 1 ) );
            if ( nPort < 1 | nPort > 65535 )
				return false; //  Malformed port
            
			return true;
        } 

        private bool ValidAddress( ref string strAddress ) 
        { 
            string[] strValue = null; 
            string strResult = null; 
            int nValue = 0; 
            int nIndex = 0; 
            
            strValue =  strAddress.Split( '.' ); 

			if ( strValue.Length != 4 )
                return false;
            
            for ( nIndex = 0; nIndex < 4; nIndex++ ) 
            { 
                nValue = Int32.Parse( strValue[ nIndex ] ); 
                if ( nValue < 0 | nValue > 255 )
                    return false;
                
                strResult += nValue.ToString();

                if ( nIndex < 3 )
					strResult += ".";
            } 
            
            if ( strResult != "0.0.0.0" & strResult != "255.255.255.255" ) 
            { 
                strAddress = strResult; 
                return true;
            } 

			return false;
        } 
        
        private void formMain_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            Label1.Text = "This will broadcast a datagram over the local network " + 
						  "on port " + queryPort + " in an attempt to discover the " + 
						  "IP address and port number for a server."; 
        } 
    } 
    
} 
