// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using SocketTools;

namespace SendMail
{
    internal class formMain : System.Windows.Forms.Form 
    {
        private bool bShowOptions;
        private int nMessageCharSet;
        private int nMessageEncoding;
        private int nMessagePriority;

        public SocketTools.MailMessage mailMessage = new SocketTools.MailMessage();
        public SocketTools.DnsClient dnsClient = new SocketTools.DnsClient();
        public SocketTools.SmtpClient smtpClient = new SocketTools.SmtpClient(); 

        #region 'Windows Form Designer generated code' 
        public formMain() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent();

            // events handled by smtpClient_OnProgress
            smtpClient.OnProgress += new SocketTools.SmtpClient.OnProgressEventHandler(smtpClient_OnProgress);
        } 

		// Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.TextBox editMessageHTML; 
        public System.Windows.Forms.TextBox editMessageText; 
        public System.Windows.Forms.Button cmdBrowse; 
        public System.Windows.Forms.ComboBox comboAttachment; 
        public System.Windows.Forms.TextBox editBcc; 
        public System.Windows.Forms.TextBox editCc; 
        public System.Windows.Forms.TextBox editSubject; 
        public System.Windows.Forms.TextBox editTo; 
        public System.Windows.Forms.TextBox editFrom; 
        public System.Windows.Forms.Label lblAttachment; 
        public System.Windows.Forms.Label lblBcc; 
        public System.Windows.Forms.Label lblCc; 
        public System.Windows.Forms.Label lblSubject; 
        public System.Windows.Forms.Label lblTo; 
        public System.Windows.Forms.Label lblFrom; 
        public System.Windows.Forms.MenuItem menuNewMessage; 
        public System.Windows.Forms.MenuItem menuSeparator1; 
        public System.Windows.Forms.MenuItem menuFileAttach; 
        public System.Windows.Forms.MenuItem menuSaveMessage; 
        public System.Windows.Forms.MenuItem menuSeparator2; 
        public System.Windows.Forms.MenuItem menuCloseFile; 
        public System.Windows.Forms.MenuItem menuFile; 
        public System.Windows.Forms.MenuItem menuFormatCharSets; 
        public System.Windows.Forms.MenuItem menuFormatEncodings; 
        public System.Windows.Forms.MenuItem menuSeparator4; 
        public System.Windows.Forms.MenuItem menuFormatPlainText; 
        public System.Windows.Forms.MenuItem menuFormatStyledText; 
        public System.Windows.Forms.MenuItem menuFormat; 
        public System.Windows.Forms.MenuItem menuMessageSend; 
        public System.Windows.Forms.MenuItem menuSeparator5; 
        public System.Windows.Forms.MenuItem menuMessagePriorities; 
        public System.Windows.Forms.MenuItem menuSeparator6; 
        public System.Windows.Forms.MenuItem menuMessageOptions; 
        public System.Windows.Forms.MenuItem menuMessage; 
        public System.Windows.Forms.MainMenu MainMenu1; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        internal System.Windows.Forms.ProgressBar ctlProgress; 
        public System.Windows.Forms.MenuItem menuCharSet1; 
        public System.Windows.Forms.MenuItem menuCharSet2; 
        public System.Windows.Forms.MenuItem menuCharSet3; 
        public System.Windows.Forms.MenuItem menuCharSet4; 
        public System.Windows.Forms.MenuItem menuCharSet5; 
        public System.Windows.Forms.MenuItem menuEncoding1; 
        public System.Windows.Forms.MenuItem menuEncoding2; 
        public System.Windows.Forms.MenuItem menuPriority1; 
        public System.Windows.Forms.MenuItem menuPriority2; 
        public System.Windows.Forms.MenuItem menuPriority3; 
        public System.Windows.Forms.MenuItem menuPriority4; 
        public System.Windows.Forms.MenuItem menuPriority5; 
        internal System.Windows.Forms.StatusBar ctlStatus; 

        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container(); 
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager( typeof( formMain ) ); 
            this.ToolTip1 = new System.Windows.Forms.ToolTip( this.components ); 
            this.editMessageHTML = new System.Windows.Forms.TextBox(); 
            this.editMessageText = new System.Windows.Forms.TextBox(); 
            this.cmdBrowse = new System.Windows.Forms.Button(); 
            this.comboAttachment = new System.Windows.Forms.ComboBox(); 
            this.editBcc = new System.Windows.Forms.TextBox(); 
            this.editCc = new System.Windows.Forms.TextBox(); 
            this.editSubject = new System.Windows.Forms.TextBox(); 
            this.editTo = new System.Windows.Forms.TextBox(); 
            this.editFrom = new System.Windows.Forms.TextBox(); 
            this.lblAttachment = new System.Windows.Forms.Label(); 
            this.lblBcc = new System.Windows.Forms.Label(); 
            this.lblCc = new System.Windows.Forms.Label(); 
            this.lblSubject = new System.Windows.Forms.Label(); 
            this.lblTo = new System.Windows.Forms.Label(); 
            this.lblFrom = new System.Windows.Forms.Label(); 
            this.menuCharSet1 = new System.Windows.Forms.MenuItem(); 
            this.menuCharSet2 = new System.Windows.Forms.MenuItem(); 
            this.menuCharSet3 = new System.Windows.Forms.MenuItem(); 
            this.menuCharSet4 = new System.Windows.Forms.MenuItem(); 
            this.menuCharSet5 = new System.Windows.Forms.MenuItem(); 
            this.menuEncoding1 = new System.Windows.Forms.MenuItem(); 
            this.menuEncoding2 = new System.Windows.Forms.MenuItem(); 
            this.menuPriority1 = new System.Windows.Forms.MenuItem(); 
            this.menuPriority2 = new System.Windows.Forms.MenuItem(); 
            this.menuPriority3 = new System.Windows.Forms.MenuItem(); 
            this.menuPriority4 = new System.Windows.Forms.MenuItem(); 
            this.menuPriority5 = new System.Windows.Forms.MenuItem(); 
            this.MainMenu1 = new System.Windows.Forms.MainMenu(); 
            this.menuFile = new System.Windows.Forms.MenuItem(); 
            this.menuNewMessage = new System.Windows.Forms.MenuItem(); 
            this.menuSeparator1 = new System.Windows.Forms.MenuItem(); 
            this.menuFileAttach = new System.Windows.Forms.MenuItem(); 
            this.menuSaveMessage = new System.Windows.Forms.MenuItem(); 
            this.menuSeparator2 = new System.Windows.Forms.MenuItem(); 
            this.menuCloseFile = new System.Windows.Forms.MenuItem(); 
            this.menuFormat = new System.Windows.Forms.MenuItem(); 
            this.menuFormatCharSets = new System.Windows.Forms.MenuItem(); 
            this.menuFormatEncodings = new System.Windows.Forms.MenuItem(); 
            this.menuSeparator4 = new System.Windows.Forms.MenuItem(); 
            this.menuFormatPlainText = new System.Windows.Forms.MenuItem(); 
            this.menuFormatStyledText = new System.Windows.Forms.MenuItem(); 
            this.menuMessage = new System.Windows.Forms.MenuItem(); 
            this.menuMessageSend = new System.Windows.Forms.MenuItem(); 
            this.menuSeparator5 = new System.Windows.Forms.MenuItem(); 
            this.menuMessagePriorities = new System.Windows.Forms.MenuItem(); 
            this.menuSeparator6 = new System.Windows.Forms.MenuItem(); 
            this.menuMessageOptions = new System.Windows.Forms.MenuItem(); 
            this.ctlProgress = new System.Windows.Forms.ProgressBar(); 
            this.ctlStatus = new System.Windows.Forms.StatusBar(); 
            this.SuspendLayout(); 
            // 
            // editMessageHTML
            // 
            this.editMessageHTML.AcceptsReturn = true; 
            this.editMessageHTML.AutoSize = false; 
            this.editMessageHTML.BackColor = System.Drawing.SystemColors.Window; 
            this.editMessageHTML.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editMessageHTML.Font = new System.Drawing.Font( "Courier New", 9.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editMessageHTML.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editMessageHTML.Location = new System.Drawing.Point( 247, 164 ); 
            this.editMessageHTML.MaxLength = 0; 
            this.editMessageHTML.Multiline = true; 
            this.editMessageHTML.Name = "editMessageHTML"; 
            this.editMessageHTML.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editMessageHTML.ScrollBars = System.Windows.Forms.ScrollBars.Both; 
            this.editMessageHTML.Size = new System.Drawing.Size( 237, 145 ); 
            this.editMessageHTML.TabIndex = 14; 
            this.editMessageHTML.Text = ""; 
            this.editMessageHTML.Visible = false; 
            this.editMessageHTML.WordWrap = false; 
            // 
            // editMessageText
            // 
            this.editMessageText.AcceptsReturn = true; 
            this.editMessageText.AutoSize = false; 
            this.editMessageText.BackColor = System.Drawing.SystemColors.Window; 
            this.editMessageText.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editMessageText.Font = new System.Drawing.Font( "Courier New", 9.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editMessageText.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editMessageText.Location = new System.Drawing.Point( 4, 164 ); 
            this.editMessageText.MaxLength = 0; 
            this.editMessageText.Multiline = true; 
            this.editMessageText.Name = "editMessageText"; 
            this.editMessageText.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editMessageText.ScrollBars = System.Windows.Forms.ScrollBars.Both; 
            this.editMessageText.Size = new System.Drawing.Size( 245, 145 ); 
            this.editMessageText.TabIndex = 13; 
            this.editMessageText.Text = ""; 
            this.editMessageText.WordWrap = false; 
            // 
            // cmdBrowse
            // 
            this.cmdBrowse.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdBrowse.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdBrowse.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdBrowse.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdBrowse.Image = ( ( System.Drawing.Image )( resources.GetObject( "cmdBrowse.Image" ) ) ); 
            this.cmdBrowse.Location = new System.Drawing.Point( 312, 132 ); 
            this.cmdBrowse.Name = "cmdBrowse"; 
            this.cmdBrowse.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdBrowse.Size = new System.Drawing.Size( 25, 21 ); 
            this.cmdBrowse.TabIndex = 12; 
            this.cmdBrowse.TextAlign = System.Drawing.ContentAlignment.BottomCenter; 
            // 
            // comboAttachment
            // 
            this.comboAttachment.BackColor = System.Drawing.SystemColors.Window; 
            this.comboAttachment.Cursor = System.Windows.Forms.Cursors.Default; 
            this.comboAttachment.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList; 
            this.comboAttachment.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.comboAttachment.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.comboAttachment.Location = new System.Drawing.Point( 72, 132 ); 
            this.comboAttachment.Name = "comboAttachment"; 
            this.comboAttachment.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.comboAttachment.Size = new System.Drawing.Size( 233, 22 ); 
            this.comboAttachment.TabIndex = 11; 
            this.comboAttachment.TabStop = false; 
            // 
            // editBcc
            // 
            this.editBcc.AcceptsReturn = true; 
            this.editBcc.AutoSize = false; 
            this.editBcc.BackColor = System.Drawing.SystemColors.Window; 
            this.editBcc.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editBcc.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editBcc.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editBcc.Location = new System.Drawing.Point( 72, 108 ); 
            this.editBcc.MaxLength = 0; 
            this.editBcc.Name = "editBcc"; 
            this.editBcc.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editBcc.Size = new System.Drawing.Size( 265, 21 ); 
            this.editBcc.TabIndex = 9; 
            this.editBcc.Text = ""; 
            // 
            // editCc
            // 
            this.editCc.AcceptsReturn = true; 
            this.editCc.AutoSize = false; 
            this.editCc.BackColor = System.Drawing.SystemColors.Window; 
            this.editCc.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editCc.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editCc.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editCc.Location = new System.Drawing.Point( 72, 84 ); 
            this.editCc.MaxLength = 0; 
            this.editCc.Name = "editCc"; 
            this.editCc.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editCc.Size = new System.Drawing.Size( 265, 21 ); 
            this.editCc.TabIndex = 7; 
            this.editCc.Text = ""; 
            // 
            // editSubject
            // 
            this.editSubject.AcceptsReturn = true; 
            this.editSubject.AutoSize = false; 
            this.editSubject.BackColor = System.Drawing.SystemColors.Window; 
            this.editSubject.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editSubject.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editSubject.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editSubject.Location = new System.Drawing.Point( 72, 60 ); 
            this.editSubject.MaxLength = 0; 
            this.editSubject.Name = "editSubject"; 
            this.editSubject.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editSubject.Size = new System.Drawing.Size( 265, 21 ); 
            this.editSubject.TabIndex = 5; 
            this.editSubject.Text = ""; 
            // 
            // editTo
            // 
            this.editTo.AcceptsReturn = true; 
            this.editTo.AutoSize = false; 
            this.editTo.BackColor = System.Drawing.SystemColors.Window; 
            this.editTo.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editTo.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editTo.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editTo.Location = new System.Drawing.Point( 72, 36 ); 
            this.editTo.MaxLength = 0; 
            this.editTo.Name = "editTo"; 
            this.editTo.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editTo.Size = new System.Drawing.Size( 265, 21 ); 
            this.editTo.TabIndex = 3; 
            this.editTo.Text = ""; 
            // 
            // editFrom
            // 
            this.editFrom.AcceptsReturn = true; 
            this.editFrom.AutoSize = false; 
            this.editFrom.BackColor = System.Drawing.SystemColors.Window; 
            this.editFrom.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editFrom.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editFrom.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editFrom.Location = new System.Drawing.Point( 72, 12 ); 
            this.editFrom.MaxLength = 0; 
            this.editFrom.Name = "editFrom"; 
            this.editFrom.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editFrom.Size = new System.Drawing.Size( 265, 21 ); 
            this.editFrom.TabIndex = 1; 
            this.editFrom.Text = ""; 
            // 
            // lblAttachment
            // 
            this.lblAttachment.BackColor = System.Drawing.SystemColors.Control; 
            this.lblAttachment.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblAttachment.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblAttachment.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblAttachment.Location = new System.Drawing.Point( 8, 136 ); 
            this.lblAttachment.Name = "lblAttachment"; 
            this.lblAttachment.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblAttachment.Size = new System.Drawing.Size( 61, 17 ); 
            this.lblAttachment.TabIndex = 10; 
            this.lblAttachment.Text = "&Attachment:"; 
            // 
            // lblBcc
            // 
            this.lblBcc.BackColor = System.Drawing.SystemColors.Control; 
            this.lblBcc.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblBcc.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblBcc.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblBcc.Location = new System.Drawing.Point( 8, 112 ); 
            this.lblBcc.Name = "lblBcc"; 
            this.lblBcc.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblBcc.Size = new System.Drawing.Size( 61, 17 ); 
            this.lblBcc.TabIndex = 8; 
            this.lblBcc.Text = "&Bcc:"; 
            // 
            // lblCc
            // 
            this.lblCc.BackColor = System.Drawing.SystemColors.Control; 
            this.lblCc.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblCc.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblCc.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblCc.Location = new System.Drawing.Point( 8, 88 ); 
            this.lblCc.Name = "lblCc"; 
            this.lblCc.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblCc.Size = new System.Drawing.Size( 61, 17 ); 
            this.lblCc.TabIndex = 6; 
            this.lblCc.Text = "&Cc:"; 
            // 
            // lblSubject
            // 
            this.lblSubject.BackColor = System.Drawing.SystemColors.Control; 
            this.lblSubject.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblSubject.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblSubject.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblSubject.Location = new System.Drawing.Point( 8, 64 ); 
            this.lblSubject.Name = "lblSubject"; 
            this.lblSubject.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblSubject.Size = new System.Drawing.Size( 61, 17 ); 
            this.lblSubject.TabIndex = 4; 
            this.lblSubject.Text = "&Subject:"; 
            // 
            // lblTo
            // 
            this.lblTo.BackColor = System.Drawing.SystemColors.Control; 
            this.lblTo.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblTo.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblTo.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblTo.Location = new System.Drawing.Point( 8, 40 ); 
            this.lblTo.Name = "lblTo"; 
            this.lblTo.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblTo.Size = new System.Drawing.Size( 61, 17 ); 
            this.lblTo.TabIndex = 2; 
            this.lblTo.Text = "&To:"; 
            // 
            // lblFrom
            // 
            this.lblFrom.BackColor = System.Drawing.SystemColors.Control; 
            this.lblFrom.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblFrom.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblFrom.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblFrom.Location = new System.Drawing.Point( 8, 16 ); 
            this.lblFrom.Name = "lblFrom"; 
            this.lblFrom.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblFrom.Size = new System.Drawing.Size( 61, 17 ); 
            this.lblFrom.TabIndex = 0; 
            this.lblFrom.Text = "&From:"; 
            // 
            // menuCharSet1
            // 
            this.menuCharSet1.Checked = true; 
            this.menuCharSet1.Index = 0; 
            this.menuCharSet1.Text = "Western European"; 
            // 
            // menuCharSet2
            // 
            this.menuCharSet2.Index = 1; 
            this.menuCharSet2.Text = "Eastern European"; 
            // 
            // menuCharSet3
            // 
            this.menuCharSet3.Index = 2; 
            this.menuCharSet3.Text = "Cyrillic"; 
            // 
            // menuCharSet4
            // 
            this.menuCharSet4.Index = 3; 
            this.menuCharSet4.Text = "Greek"; 
            // 
            // menuCharSet5
            // 
            this.menuCharSet5.Index = 4; 
            this.menuCharSet5.Text = "Turkish"; 
            // 
            // menuEncoding1
            // 
            this.menuEncoding1.Checked = true; 
            this.menuEncoding1.Index = 0; 
            this.menuEncoding1.Text = "7 Bit Text"; 
            // 
            // menuEncoding2
            // 
            this.menuEncoding2.Index = 1; 
            this.menuEncoding2.Text = "Quoted Printable"; 
            // 
            // menuPriority1
            // 
            this.menuPriority1.Index = 0; 
            this.menuPriority1.Text = "Highest"; 
            // 
            // menuPriority2
            // 
            this.menuPriority2.Index = 1; 
            this.menuPriority2.Text = "High"; 
            // 
            // menuPriority3
            // 
            this.menuPriority3.Checked = true; 
            this.menuPriority3.Index = 2; 
            this.menuPriority3.Text = "Normal"; 
            // 
            // menuPriority4
            // 
            this.menuPriority4.Index = 3; 
            this.menuPriority4.Text = "Low"; 
            // 
            // menuPriority5
            // 
            this.menuPriority5.Index = 4; 
            this.menuPriority5.Text = "Lowest"; 
            // 
            // MainMenu1
            // 
            this.MainMenu1.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] { this.menuFile, this.menuFormat, this.menuMessage } ); 
            // 
            // menuFile
            // 
            this.menuFile.Index = 0; 
            this.menuFile.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] { this.menuNewMessage, this.menuSeparator1, this.menuFileAttach, this.menuSaveMessage, this.menuSeparator2, this.menuCloseFile } ); 
            this.menuFile.Text = "&File"; 
            // 
            // menuNewMessage
            // 
            this.menuNewMessage.Index = 0; 
            this.menuNewMessage.Shortcut = System.Windows.Forms.Shortcut.CtrlN; 
            this.menuNewMessage.Text = "&New Message"; 
            // 
            // menuSeparator1
            // 
            this.menuSeparator1.Index = 1; 
            this.menuSeparator1.Text = "-"; 
            // 
            // menuFileAttach
            // 
            this.menuFileAttach.Index = 2; 
            this.menuFileAttach.Text = "&Attach File"; 
            // 
            // menuSaveMessage
            // 
            this.menuSaveMessage.Index = 3; 
            this.menuSaveMessage.Text = "&Save Message"; 
            // 
            // menuSeparator2
            // 
            this.menuSeparator2.Index = 4; 
            this.menuSeparator2.Text = "-"; 
            // 
            // menuCloseFile
            // 
            this.menuCloseFile.Index = 5; 
            this.menuCloseFile.Text = "Close"; 
            // 
            // menuFormat
            // 
            this.menuFormat.Index = 1; 
            this.menuFormat.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] { this.menuFormatCharSets, this.menuFormatEncodings, this.menuSeparator4, this.menuFormatPlainText, this.menuFormatStyledText } ); 
            this.menuFormat.Text = "F&ormat"; 
            // 
            // menuFormatCharSets
            // 
            this.menuFormatCharSets.Index = 0; 
            this.menuFormatCharSets.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] { this.menuCharSet1, this.menuCharSet2, this.menuCharSet3, this.menuCharSet4, this.menuCharSet5 } ); 
            this.menuFormatCharSets.Text = "Character Set"; 
            // 
            // menuFormatEncodings
            // 
            this.menuFormatEncodings.Index = 1; 
            this.menuFormatEncodings.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] { this.menuEncoding1, this.menuEncoding2 } ); 
            this.menuFormatEncodings.Text = "Encoding"; 
            // 
            // menuSeparator4
            // 
            this.menuSeparator4.Index = 2; 
            this.menuSeparator4.Text = "-"; 
            // 
            // menuFormatPlainText
            // 
            this.menuFormatPlainText.Checked = true; 
            this.menuFormatPlainText.Index = 3; 
            this.menuFormatPlainText.Text = "Plain Text"; 
            // 
            // menuFormatStyledText
            // 
            this.menuFormatStyledText.Index = 4; 
            this.menuFormatStyledText.Text = "Styled Text (HTML)"; 
            // 
            // menuMessage
            // 
            this.menuMessage.Index = 2; 
            this.menuMessage.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] { this.menuMessageSend, this.menuSeparator5, this.menuMessagePriorities, this.menuSeparator6, this.menuMessageOptions } ); 
            this.menuMessage.Text = "&Message"; 
            // 
            // menuMessageSend
            // 
            this.menuMessageSend.Index = 0; 
            this.menuMessageSend.Text = "Send Message"; 
            // 
            // menuSeparator5
            // 
            this.menuSeparator5.Index = 1; 
            this.menuSeparator5.Text = "-"; 
            // 
            // menuMessagePriorities
            // 
            this.menuMessagePriorities.Index = 2; 
            this.menuMessagePriorities.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] { this.menuPriority1, this.menuPriority2, this.menuPriority3, this.menuPriority4, this.menuPriority5 } ); 
            this.menuMessagePriorities.Text = "Priority"; 
            // 
            // menuSeparator6
            // 
            this.menuSeparator6.Index = 3; 
            this.menuSeparator6.Text = "-"; 
            // 
            // menuMessageOptions
            // 
            this.menuMessageOptions.Index = 4; 
            this.menuMessageOptions.Text = "Options"; 
            // 
            // ctlProgress
            // 
            this.ctlProgress.Location = new System.Drawing.Point( 302, 379 ); 
            this.ctlProgress.Name = "ctlProgress"; 
            this.ctlProgress.Size = new System.Drawing.Size( 225, 14 ); 
            this.ctlProgress.TabIndex = 16; 
            // 
            // ctlStatus
            // 
            this.ctlStatus.Location = new System.Drawing.Point( 0, 399 ); 
            this.ctlStatus.Name = "ctlStatus"; 
            this.ctlStatus.Size = new System.Drawing.Size( 542, 17 ); 
            this.ctlStatus.TabIndex = 17; 
            // 
            // formMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 ); 
            this.BackColor = System.Drawing.SystemColors.Control; 
            this.ClientSize = new System.Drawing.Size( 542, 416 ); 
            this.Controls.Add( this.ctlProgress ); 
            this.Controls.Add( this.editMessageHTML ); 
            this.Controls.Add( this.editMessageText ); 
            this.Controls.Add( this.editBcc ); 
            this.Controls.Add( this.editCc ); 
            this.Controls.Add( this.editSubject ); 
            this.Controls.Add( this.editTo ); 
            this.Controls.Add( this.editFrom ); 
            this.Controls.Add( this.cmdBrowse ); 
            this.Controls.Add( this.comboAttachment ); 
            this.Controls.Add( this.lblAttachment ); 
            this.Controls.Add( this.lblBcc ); 
            this.Controls.Add( this.lblCc ); 
            this.Controls.Add( this.lblSubject ); 
            this.Controls.Add( this.lblTo ); 
            this.Controls.Add( this.lblFrom ); 
            this.Controls.Add( this.ctlStatus ); 
            this.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Location = new System.Drawing.Point( 179, 203 ); 
            this.Menu = this.MainMenu1; 
            this.MinimumSize = new System.Drawing.Size( 550, 450 ); 
            this.Name = "formMain"; 
            this.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen; 
            this.Text = "SocketTools SendMail Example"; 
            this.ResumeLayout( false ); 
            
            // events handled by formMain_Load
            base.Load += new System.EventHandler( formMain_Load ); 
            // events handled by formMain_Activated
            base.Activated += new System.EventHandler( formMain_Activated ); 
            // events handled by formMain_Resize
            base.Resize += new System.EventHandler( formMain_Resize ); 
            // events handled by formMain_Closed
            base.Closed += new System.EventHandler( formMain_Closed ); 
            // events handled by menuNewMessage_Popup
            menuNewMessage.Popup += new System.EventHandler( menuNewMessage_Popup ); 
            // events handled by menuNewMessage_Click
            menuNewMessage.Click += new System.EventHandler( menuNewMessage_Click ); 
            // events handled by menuSaveMessage_Popup
            menuSaveMessage.Popup += new System.EventHandler( menuSaveMessage_Popup ); 
            // events handled by menuSaveMessage_Click
            menuSaveMessage.Click += new System.EventHandler( menuSaveMessage_Click ); 
            // events handled by menuFileAttach_Popup
            menuFileAttach.Popup += new System.EventHandler( menuFileAttach_Popup ); 
            // events handled by menuFileAttach_Click
            menuFileAttach.Click += new System.EventHandler( menuFileAttach_Click ); 
            // events handled by menuCloseFile_Popup
            menuCloseFile.Popup += new System.EventHandler( menuCloseFile_Popup ); 
            // events handled by menuCloseFile_Click
            menuCloseFile.Click += new System.EventHandler( menuCloseFile_Click ); 
            // events handled by menuFormatPlainText_Popup
            menuFormatPlainText.Popup += new System.EventHandler( menuFormatPlainText_Popup ); 
            // events handled by menuFormatPlainText_Click
            menuFormatPlainText.Click += new System.EventHandler( menuFormatPlainText_Click ); 
            // events handled by menuFormatStyledText_Popup
            menuFormatStyledText.Popup += new System.EventHandler( menuFormatStyledText_Popup ); 
            // events handled by menuFormatStyledText_Click
            menuFormatStyledText.Click += new System.EventHandler( menuFormatStyledText_Click ); 
            // events handled by menuMessageSend_Popup
            menuMessageSend.Popup += new System.EventHandler( menuMessageSend_Popup ); 
            // events handled by menuMessageSend_Click
            menuMessageSend.Click += new System.EventHandler( menuMessageSend_Click ); 
            // events handled by menuMessageOptions_Popup
            menuMessageOptions.Popup += new System.EventHandler( menuMessageOptions_Popup ); 
            // events handled by menuMessageOptions_Click
            menuMessageOptions.Click += new System.EventHandler( menuMessageOptions_Click ); 
            // events handled by cmdBrowse_Click
            cmdBrowse.Click += new System.EventHandler( cmdBrowse_Click ); 
            // events handled by menuCharSet1_Click
            menuCharSet1.Click += new System.EventHandler( menuCharSet1_Click ); 
            // events handled by menuCharSet2_Click
            menuCharSet2.Click += new System.EventHandler( menuCharSet2_Click ); 
            // events handled by menuCharSet3_Click
            menuCharSet3.Click += new System.EventHandler( menuCharSet3_Click ); 
            // events handled by menuCharSet4_Click
            menuCharSet4.Click += new System.EventHandler( menuCharSet4_Click ); 
            // events handled by menuCharSet5_Click
            menuCharSet5.Click += new System.EventHandler( menuCharSet5_Click ); 
            // events handled by menuEncoding1_Click
            menuEncoding1.Click += new System.EventHandler( menuEncoding1_Click ); 
            // events handled by menuEncoding2_Click
            menuEncoding2.Click += new System.EventHandler( menuEncoding2_Click ); 
            // events handled by menuPriority1_Click
            menuPriority1.Click += new System.EventHandler( menuPriority1_Click ); 
            // events handled by menuPriority2_Click
            menuPriority2.Click += new System.EventHandler( menuPriority2_Click ); 
            // events handled by menuPriority3_Click
            menuPriority3.Click += new System.EventHandler( menuPriority3_Click ); 
            // events handled by menuPriority4_Click
            menuPriority4.Click += new System.EventHandler( menuPriority4_Click ); 
            // events handled by menuPriority5_Click
            menuPriority5.Click += new System.EventHandler( menuPriority5_Click ); 
        } 
        #endregion 
        
        // 
        //  Initialize the controls on the form and load any options
        //  that were stored (see options.bas module)
        // 
        private void formMain_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( !( mailMessage.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            if ( !( dnsClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            if ( !( smtpClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            nMessageCharSet = System.Convert.ToInt32( SocketTools.MailMessage.MimeCharacterSet.charsetUSASCII ); 
            nMessageEncoding = System.Convert.ToInt32( SocketTools.MailMessage.MimeEncoding.encoding7Bit ); 
            nMessagePriority = 3; //  Normal
            
            modOptions.LoadOptions(); 
            bShowOptions = true; //  Show options when form initializes
            
            if ( modOptions.g_strSenderAddress.Length > 0 ) 
            { 
                editFrom.Text = '"' + modOptions.g_strSenderName +  '"' + " <" + modOptions.g_strSenderAddress + ">"; 
            } 
            
            UpdateMenu(); 
            formMain_Resize( eventSender, eventArgs ); 
        } 
        
        private void formMain_Activated( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( bShowOptions ) 
            { 
                formOptions dlgOptions = new formOptions(); 
                
                bShowOptions = false; 
                dlgOptions.ShowDialog(); 
                
                if (  modOptions.g_strSenderAddress.Length > 0 ) 
                { 
                    editFrom.Text = '"' + modOptions.g_strSenderName +  '"' + " <" + modOptions.g_strSenderAddress + ">"; 
                } 
            } 
        } 
        
        // 
        //  Resize controls when the user resizes the form
        // 
        private void formMain_Resize( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editFrom.Width = ( ClientRectangle.Width - editFrom.Left ) - 10; 
            editTo.Width = ( ClientRectangle.Width - editTo.Left ) - 10; 
            editSubject.Width = ( ClientRectangle.Width - editSubject.Left ) - 10; 
            editCc.Width = ( ClientRectangle.Width - editCc.Left ) - 10; 
            editBcc.Width = ( ClientRectangle.Width - editBcc.Left ) - 10; 
            cmdBrowse.Left = ( ClientRectangle.Width - cmdBrowse.Width ) - 10; 
            comboAttachment.Width = ( cmdBrowse.Left - comboAttachment.Left ) - 10; 
            editMessageText.Height = ( ClientRectangle.Height - editMessageText.Top ) - ctlStatus.Height - 10; 
            editMessageText.Width = ( ClientRectangle.Width - editMessageText.Left ) - 5; 
            editMessageHTML.Left = editMessageText.Left; 
            editMessageHTML.Top = editMessageText.Top; 
            editMessageHTML.Height = ( ClientRectangle.Height - editMessageHTML.Top ) - ctlStatus.Height - 10; 
            editMessageHTML.Width = ClientRectangle.Width - editMessageHTML.Left - 5; 
            ctlProgress.Left = ( ClientRectangle.Width - ctlProgress.Width ) - 10; 
            ctlProgress.Top = ( ClientRectangle.Height - ctlStatus.Height ); 
        } 
        
        private void formMain_Closed( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            mailMessage.Uninitialize(); 
            dnsClient.Uninitialize(); 
            smtpClient.Uninitialize(); 
        } 
        
        // 
        //  Clear the current message
        // 
        public void menuNewMessage_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuNewMessage_Click( eventSender, eventArgs ); 
        } 
        
        public void menuNewMessage_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            mailMessage.ClearMessage(); 
            
            editFrom.Text = ""; 
            editTo.Text = ""; 
            editSubject.Text = ""; 
            editCc.Text = ""; 
            editBcc.Text = ""; 
            editMessageText.Text = ""; 
            editMessageHTML.Text = ""; 
            comboAttachment.Items.Clear(); 
            
            if (  modOptions.g_strSenderAddress.Length > 0 ) 
            { 
                editFrom.Text =  '"' + modOptions.g_strSenderName +  '"' + " <" + modOptions.g_strSenderAddress + ">"; 
            } 
        } 
        
        // 
        //  Save the current message to a file. The CreateMessage helper function
        //  is called, and then the user is prompted for a file to save the
        //  message to
        // 
        public void menuSaveMessage_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuSaveMessage_Click( eventSender, eventArgs ); 
        } 
        
        public void menuSaveMessage_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            SaveFileDialog saveDialog = new SaveFileDialog(); 
            
            if ( !( CreateMessage() ) ) 
            { 
                Interaction.MsgBox( "Unable to create message" + mailMessage.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                return; 
            } 
            
            saveDialog.DefaultExt = ".txt"; 
            saveDialog.Title = "Save Message"; 
            saveDialog.FileName = ""; 
            saveDialog.FilterIndex = 1; 
            saveDialog.OverwritePrompt = true; 
            saveDialog.CheckPathExists = true; 
            saveDialog.Filter = "Text Files (*.txt)|*.txt|" + "E-Mail Message Files (*.eml)|*.eml|" + "All Files (*.*)|*.*"; 
            
            if ( saveDialog.ShowDialog() != DialogResult.OK ) 
            { 
                return; 
            } 
            
            if ( !( mailMessage.ExportMessage( saveDialog.FileName ) ) ) 
            { 
                Interaction.MsgBox( "Unable to save message to " + saveDialog.FileName + "\r\n" + mailMessage.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                return; 
            } 
        } 
        
        // 
        //  Select a file to be attached to the message and add it to the
        //  combo box control which lists the current file attachments.
        //  Note that this does not actually attach the file to the current
        //  message; that is done in the CreateMessage helper function
        // 
        public void menuFileAttach_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuFileAttach_Click( eventSender, eventArgs ); 
        } 
        
        public void menuFileAttach_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            OpenFileDialog openDialog = new OpenFileDialog(); 
            
            openDialog.Title = "Attach File"; 
            openDialog.DefaultExt = ".txt"; 
            openDialog.FileName = ""; 
            openDialog.FilterIndex = 1; 
            openDialog.Filter = "All Files (*.*)|*.*"; 
            openDialog.CheckPathExists = true; 
            openDialog.CheckFileExists = true; 
            
            if ( openDialog.ShowDialog() != DialogResult.OK ) 
            { 
                return; 
            } 
            
            comboAttachment.Items.Add( openDialog.FileName ); 
            comboAttachment.SelectedIndex = comboAttachment.Items.Count - 1; 
        } 
        
        public void menuCloseFile_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuCloseFile_Click( eventSender, eventArgs ); 
        } 
        
        public void menuCloseFile_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            this.Close(); 
        } 
        
        // 
        //  Display the multiline edit control which contains the plain text
        //  version of the message
        // 
        public void menuFormatPlainText_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuFormatPlainText_Click( eventSender, eventArgs ); 
        } 
        
        public void menuFormatPlainText_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editMessageText.Visible = true; 
            editMessageHTML.Visible = false; 
            menuFormatPlainText.Checked = true; 
            menuFormatStyledText.Checked = false; 
            ctlStatus.Text = "Enter the plain text version of your message"; 
        } 
        
        // 
        //  Display the multiline edit control which contains the styled (HTML)
        //  text version of the message. See the CreateMessage helper function
        //  for how the sample handles HTML text. A more sophisticated approach
        //  would be to actually create an HTML editor, but that is beyond the
        //  scope of this example.
        // 
        public void menuFormatStyledText_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuFormatStyledText_Click( eventSender, eventArgs ); 
        } 
        
        public void menuFormatStyledText_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editMessageText.Visible = false; 
            editMessageHTML.Visible = true; 
            menuFormatPlainText.Checked = false; 
            menuFormatStyledText.Checked = true; 
            ctlStatus.Text = "Enter the styled text version of your message"; 
        } 
        
        // 
        //  Call the CreateMessage helper function to create the message and
        //  then deliver it to the specified recipients
        // 
        public void menuMessageSend_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuMessageSend_Click( eventSender, eventArgs ); 
        } 
        
        public void menuMessageSend_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strSender = null; 
            string strRecipient = null; 
            string strDomain = null; 
            int nPos = 0; 
            int nDelivered = 0; 
            int nIndex = 0; 
            
            if ( !( CreateMessage() ) ) 
            { 
                ctlStatus.Text = mailMessage.LastErrorString; 
                Interaction.MsgBox( "Unable to create a new message" + "\r\n" + mailMessage.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                return; 
            } 
            
            strSender = mailMessage.Sender; 
            if ( strSender.Length == 0 ) 
            { 
                Interaction.MsgBox( "There is no valid sender for this message", MsgBoxStyle.Exclamation, null ); 
                return; 
            } 
            
            if ( mailMessage.Recipients == 0 ) 
            { 
                Interaction.MsgBox( "There are no recipients for this message", MsgBoxStyle.Information, null ); 
                return; 
            } 
            
            ctlProgress.Minimum = 0; 
            ctlProgress.Maximum = 100; 
            ctlProgress.Value = 0; 
            nDelivered = 0; 
            
            for ( nIndex=0; nIndex <= mailMessage.Recipients - 1; nIndex++ ) 
            { 
                strRecipient = mailMessage.Recipient[ nIndex ]; 
                smtpClient.Reset(); 
                
                // 
                //  The user has specified that a relay server is to be used
                //  (under the Message | Options menu) then set those properties
                //  so that our message will always be routed through that server
                // 
                if ( modOptions.g_bRelayMessages ) 
                { 
                    smtpClient.HostName = modOptions.g_strRelayServer; 
                    smtpClient.RemotePort = modOptions.g_nRelayPort; 
                    if ( modOptions.g_bAuthenticate ) 
                    { 
                        smtpClient.UserName = modOptions.g_strUserName; 
                        smtpClient.Password = modOptions.g_strPassword; 
                    } 
                    smtpClient.Extended = true; 
                } 
                else 
                { 
                    string transTemp0 = "@"; 
                    nPos =  strRecipient.IndexOf( transTemp0 ) + 1; 
                    if ( nPos > 0 )
                    { 
                        strDomain =  strRecipient.Substring( nPos ); 
                    } 
                    dnsClient.HostName = strDomain; 
                    if ( dnsClient.MailExchanges == 0 ) 
                    { 
                        smtpClient.HostName = dnsClient.HostName; 
                        smtpClient.RemotePort = SocketTools.SmtpClient.smtpPortDefault; 
                    } 
                    else 
                    { 
                        smtpClient.HostName = dnsClient.MailExchange[ 0 ]; 
                        smtpClient.RemotePort = SocketTools.SmtpClient.smtpPortDefault; 
                    } 
                } 
                
                if ( !( smtpClient.Connect() ) ) 
                { 
                    Interaction.MsgBox( smtpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                    break;
                } 
                
                ctlProgress.Value = 0; 
                ctlStatus.Text = "Sending message to " + strRecipient; 
                
                if ( !( smtpClient.SendMessage( strSender, strRecipient, mailMessage.Message ) ) ) 
                { 
                    ctlStatus.Text = mailMessage.LastErrorString; 
                    Interaction.MsgBox( "Unable to send message" + "\r\n" + smtpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                    smtpClient.Disconnect(); 
                    break;
                } 
                
                smtpClient.Disconnect(); 
                nDelivered = nDelivered + 1; 
            } 
            
            ctlProgress.Value = 0; 
            ctlStatus.Text = ""; 
            
            if ( nDelivered > 0 ) 
            { 
                ctlStatus.Text = "Message delivered to " + nDelivered + " recipient(s)"; 
            } 
        } 
        
        // 
        //  Display the options dialog which allows the user to enter
        //  some default values and select whether or not a relay server
        //  should be used to deliver messages
        // 
        public void menuMessageOptions_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuMessageOptions_Click( eventSender, eventArgs ); 
        } 
        
        public void menuMessageOptions_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            formOptions dlgOptions = new formOptions(); 
            
            dlgOptions.ShowDialog(); 
            
            if (  modOptions.g_strSenderAddress.Length > 0 ) 
            { 
                editFrom.Text = '"' + modOptions.g_strSenderName +  '"' + " <" + modOptions.g_strSenderAddress + ">"; 
            } 
        } 
        
        private void cmdBrowse_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuFileAttach_Click( menuFileAttach, new System.EventArgs() ); 
        } 
        
        // 
        //  A helper function which uses the ComposeMessage method to create a
        //  message, followed by attaching each of the listed files to the
        //  message. This function is called when the user selects the menu option
        //  to send a message or save the message to a text file
        // 
        private bool CreateMessage() 
        { 
            bool createMessageReturn = false;
            string strFontName = null; 
            string strFontSize = null; 
            string strMessageHTML = null; 
            int nIndex = 0; 
            
            createMessageReturn = true; 
            
            // 
            //  If the user has entered any HTML text, then make sure that it is
            //  properly formed HTML and specify a font and font size to use;
            //  this is hard-coded, but an application would obviously want to
            //  make something like font selection customizable
            // 
            string transTemp1 = Strings.Trim( editMessageHTML.Text ); 
            if ( transTemp1.Length == 0 ) 
            { 
                strMessageHTML = ""; 
            } 
            else 
            { 
                strFontName = "Arial"; 
                strFontSize = "3"; 
                strMessageHTML = "<html><head><title>" + editSubject.Text + "</title></head>" + "<body><font " + "face=" +  '"' + strFontName +  "\" size=" + '"' + strFontSize + "\">" + "\r\n" + editMessageHTML.Text + "\r\n" + "</font></body></html>"; 
            } 
            
            // 
            //  Use the ComposeMessage method to do all of the hard work of
            //  creating the actual message
            // 
            if ( !( mailMessage.ComposeMessage( editFrom.Text, editTo.Text, editCc.Text, editBcc.Text, editSubject.Text, editMessageText.Text, strMessageHTML, ( ( SocketTools.MailMessage.MimeCharacterSet )( nMessageCharSet ) ), ( ( SocketTools.MailMessage.MimeEncoding )( nMessageEncoding ) ) ) ) ) 
            { 
                createMessageReturn = false; 
                return createMessageReturn; 
            } 
            
            // 
            //  Attach each file that was selected by the user
            // 
            for ( nIndex=0; nIndex <= comboAttachment.Items.Count - 1; nIndex++ ) 
            { 
                if ( !( mailMessage.AttachFile( System.Convert.ToString( comboAttachment.Items[ nIndex ] ) ) ) ) 
                { 
                    createMessageReturn = false; 
                    return createMessageReturn; 
                } 
            } 
            
            switch ( nMessagePriority ) 
            {
                case 1:
                    mailMessage.Priority = "1 (Highest)"; 
                    break;
                case 2:
                    mailMessage.Priority = "2 (High)"; 
                    break;
                case 3:
                    mailMessage.Priority = "3 (Normal)"; 
                    break;
                case 4:
                    mailMessage.Priority = "4 (Low)"; 
                    break;
                case 5:
                    mailMessage.Priority = "5 (Lowest)"; 
                    break;
            }
            
            
            // 
            //  Set the Organization property to the name of the current user's
            //  organization or company; this is specified in the options dialog
            // 
            mailMessage.Organization = modOptions.g_strOrganization; 
            
            return createMessageReturn;
        } 
        
        private void smtpClient_OnProgress( object sender, SocketTools.SmtpClient.ProgressEventArgs e ) 
        { 
            ctlProgress.Value = e.Percent; 
        } 
        
        public void UpdateMenu() 
        { 
            menuCharSet1.Checked = false; 
            menuCharSet2.Checked = false; 
            menuCharSet3.Checked = false; 
            menuCharSet4.Checked = false; 
            menuCharSet5.Checked = false; 
            
            switch ( (SocketTools.MailMessage.MimeCharacterSet)nMessageCharSet ) 
            {
                case SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_1:
                    menuCharSet1.Checked = true; 
                    
                    break;
                case SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_2:
                    menuCharSet2.Checked = true; 
                    
                    break;
                case SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_5:
                    menuCharSet3.Checked = true; 
                    
                    break;
                case SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_7:
                    menuCharSet4.Checked = true; 
                    
                    break;
                case SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_9:
                    menuCharSet5.Checked = true; 
                    break;
            }
            
            
            menuEncoding1.Checked = false; 
            menuEncoding2.Checked = false; 
            
            switch ( (SocketTools.MailMessage.MimeEncoding)nMessageEncoding ) 
            {
                case SocketTools.MailMessage.MimeEncoding.encoding7Bit:
                    menuEncoding1.Checked = true; 
                    
                    break;
                case SocketTools.MailMessage.MimeEncoding.encodingQuoted:
                    menuEncoding2.Checked = true; 
                    break;
            }
            
            
            menuPriority1.Checked = false; 
            menuPriority2.Checked = false; 
            menuPriority3.Checked = false; 
            menuPriority4.Checked = false; 
            menuPriority5.Checked = false; 
            
            switch ( nMessagePriority ) 
            {
                case 1:
                    menuPriority1.Checked = true; 
                    
                    break;
                case 2:
                    menuPriority2.Checked = true; 
                    
                    break;
                case 3:
                    menuPriority3.Checked = true; 
                    
                    break;
                case 4:
                    menuPriority4.Checked = true; 
                    
                    break;
                case 5:
                    menuPriority5.Checked = true; 
                    break;
            }
        } 
        
        private void menuCharSet1_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessageCharSet = System.Convert.ToInt32( SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_1 ); 
            UpdateMenu(); 
        } 
        
        private void menuCharSet2_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessageCharSet = System.Convert.ToInt32( SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_2 ); 
            UpdateMenu(); 
        } 
        
        private void menuCharSet3_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessageCharSet = System.Convert.ToInt32( SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_5 ); 
            UpdateMenu(); 
        } 
        
        private void menuCharSet4_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessageCharSet = System.Convert.ToInt32( SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_7 ); 
            UpdateMenu(); 
        } 
        
        private void menuCharSet5_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessageCharSet = System.Convert.ToInt32( SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_9 ); 
            UpdateMenu(); 
        } 
        
        private void menuEncoding1_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessageEncoding = System.Convert.ToInt32( SocketTools.MailMessage.MimeEncoding.encoding7Bit ); 
            UpdateMenu(); 
        } 
        
        private void menuEncoding2_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessageEncoding = System.Convert.ToInt32( SocketTools.MailMessage.MimeEncoding.encodingQuoted ); 
            UpdateMenu(); 
        } 
        
        private void menuPriority1_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessagePriority = 1; //  Highest
            UpdateMenu(); 
        } 
        
        private void menuPriority2_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessagePriority = 2; //  High
            UpdateMenu(); 
        } 
        
        private void menuPriority3_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessagePriority = 3; //  Normal
            UpdateMenu(); 
        } 
        
        private void menuPriority4_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessagePriority = 4; //  Low
            UpdateMenu(); 
        } 
        
        private void menuPriority5_Click( System.Object sender, System.EventArgs e ) 
        { 
            nMessagePriority = 5; //  Lowest
            UpdateMenu(); 
        } 
        
        [STAThread]
        public static void Main() { Application.Run( new formMain() ); }
    } 
} 
