// SocketWrench 10
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using SocketTools; 

namespace UdpEcho
{
    public class Form1 : System.Windows.Forms.Form 
    { 
        private SocketTools.SocketWrench Socket = new SocketTools.SocketWrench(); 
        
        #region 'Windows Form Designer generated code' 
        
        public Form1() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
            
            // Add any initialization after the InitializeComponent() call
            if ( !( Socket.Initialize() ) ) 
            { 
                MessageBox.Show( "Unable to initialize SocketWrench component" ); 
                System.Environment.Exit( 0 ); 
            } 
		
			// Add handler for OnRead event
			Socket.OnRead += new System.EventHandler( Socket_OnRead ); 
		} 
        
        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool disposing ) 
        { 
            if ( disposing ) 
            { 
                if ( !( ( components == null ) ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.  
        // Do not modify it using the code editor.
        internal System.Windows.Forms.Label Label1; 
        internal System.Windows.Forms.TextBox TextBox1; 
        internal System.Windows.Forms.Label Label2; 
        internal System.Windows.Forms.TextBox TextBox2; 
        internal System.Windows.Forms.ListBox ListBox1; 
        internal System.Windows.Forms.Button Button1; 
        internal System.Windows.Forms.Label Label3; 
        internal System.Windows.Forms.TextBox TextBox3; 

        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.Label1 = new System.Windows.Forms.Label(); 
            this.TextBox1 = new System.Windows.Forms.TextBox(); 
            this.Label2 = new System.Windows.Forms.Label(); 
            this.TextBox2 = new System.Windows.Forms.TextBox(); 
            this.ListBox1 = new System.Windows.Forms.ListBox(); 
            this.Button1 = new System.Windows.Forms.Button(); 
            this.Label3 = new System.Windows.Forms.Label(); 
            this.TextBox3 = new System.Windows.Forms.TextBox(); 
            this.SuspendLayout(); 
            // 
            // Label1
            // 
            this.Label1.Location = new System.Drawing.Point( 16, 16 ); 
            this.Label1.Name = "Label1"; 
            this.Label1.Size = new System.Drawing.Size( 60, 16 ); 
            this.Label1.TabIndex = 0; 
            this.Label1.Text = "Address:"; 
            // 
            // TextBox1
            // 
            this.TextBox1.Location = new System.Drawing.Point( 80, 14 ); 
            this.TextBox1.Name = "TextBox1"; 
            this.TextBox1.Size = new System.Drawing.Size( 200, 20 ); 
            this.TextBox1.TabIndex = 1; 
            this.TextBox1.Text = ""; 
            // 
            // Label2
            // 
            this.Label2.Location = new System.Drawing.Point( 300, 16 ); 
            this.Label2.Name = "Label2"; 
            this.Label2.Size = new System.Drawing.Size( 30, 16 ); 
            this.Label2.TabIndex = 2; 
            this.Label2.Text = "Port:"; 
            // 
            // TextBox2
            // 
            this.TextBox2.Location = new System.Drawing.Point( 336, 14 ); 
            this.TextBox2.Name = "TextBox2"; 
            this.TextBox2.Size = new System.Drawing.Size( 40, 20 ); 
            this.TextBox2.TabIndex = 3; 
            this.TextBox2.Text = ""; 
            // 
            // ListBox1
            // 
            this.ListBox1.HorizontalScrollbar = true; 
            this.ListBox1.Location = new System.Drawing.Point( 16, 72 ); 
            this.ListBox1.Name = "ListBox1"; 
            this.ListBox1.ScrollAlwaysVisible = true; 
            this.ListBox1.Size = new System.Drawing.Size( 360, 108 ); 
            this.ListBox1.TabIndex = 6; 
            this.ListBox1.TabStop = false; 
            // 
            // Button1
            // 
            this.Button1.Location = new System.Drawing.Point( 152, 192 ); 
            this.Button1.Name = "Button1"; 
            this.Button1.Size = new System.Drawing.Size( 90, 30 ); 
            this.Button1.TabIndex = 7; 
            this.Button1.Text = "Send"; 
            // 
            // Label3
            // 
            this.Label3.Location = new System.Drawing.Point( 16, 42 ); 
            this.Label3.Name = "Label3"; 
            this.Label3.Size = new System.Drawing.Size( 56, 16 ); 
            this.Label3.TabIndex = 4; 
            this.Label3.Text = "Message:"; 
            // 
            // TextBox3
            // 
            this.TextBox3.Location = new System.Drawing.Point( 80, 40 ); 
            this.TextBox3.Name = "TextBox3"; 
            this.TextBox3.Size = new System.Drawing.Size( 296, 20 ); 
            this.TextBox3.TabIndex = 5; 
            this.TextBox3.Text = ""; 
            // 
            // Form1
            // 
            this.AcceptButton = this.Button1; 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 ); 
            this.ClientSize = new System.Drawing.Size( 394, 232 ); 
            this.Controls.Add( this.TextBox3 ); 
            this.Controls.Add( this.Label3 ); 
            this.Controls.Add( this.Button1 ); 
            this.Controls.Add( this.ListBox1 ); 
            this.Controls.Add( this.TextBox2 ); 
            this.Controls.Add( this.Label2 ); 
            this.Controls.Add( this.TextBox1 ); 
            this.Controls.Add( this.Label1 ); 
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog; 
            this.MaximizeBox = false; 
            this.Name = "Form1"; 
            this.Text = "UDP Echo Example"; 
            this.ResumeLayout( false ); 
            
            // events handled by Button1_Click
            Button1.Click += new System.EventHandler( Button1_Click ); 
        } 
        
		[STAThread]
		public static void Main() { Application.Run( new Form1() ); }
		#endregion 
        
        private void UpdateListBox( string message ) 
        { 
            ListBox1.Items.Add( message ); 
            ListBox1.SelectedIndex = ListBox1.Items.Count - 1; 
            ListBox1.ClearSelected(); 
        } 
        
        private void Button1_Click( object sender, System.EventArgs e ) 
        { 
            string strHostAddress = null; 
            string strMessage = null; 
            int nHostPort = 0; 
            int nResult = 0; 
            
            strHostAddress = TextBox1.Text.Trim(); 
            if ( strHostAddress.Length == 0 ) 
            { 
                MessageBox.Show( "Please specify a valid IP address" ); 
                return; 
            } 
            
            nHostPort = Int32.Parse( TextBox2.Text ); 
            if ( nHostPort < 1 | nHostPort > 65535 ) 
            { 
                MessageBox.Show( "Please specify a valid port number" ); 
                return; 
            } 
            
            strMessage = TextBox3.Text.Trim(); 
            if ( strMessage.Length == 0 ) 
            { 
                MessageBox.Show( "Please enter a message to send to the remote host" ); 
                return; 
            } 
            
            //  If the Handle property is -1, this means that a socket has not been created,
            //  probably because this is the first time the user has clicked the button.
            //  Initialize the socket properties and create a datagram socket using the Bind
            //  method. By setting Blocking to false, the OnRead event will be raised when
            //  the remote host echoes our message back to us.
            if ( Socket.Handle == -1 ) 
            { 
                Socket.Protocol = SocketTools.SocketWrench.SocketProtocol.socketDatagram; 
                Socket.Blocking = false; 
                
                //  Bind to any valid network interface and any available port number.
                if ( !( Socket.Bind( "0.0.0.0", 0 ) ) ) 
                { 
                    MessageBox.Show( Socket.LastErrorString ); 
                    return; 
                } 
            } 
            
            //  Use the WriteTo method to send our datagram to the specified address and
            //  port number; this method will return the number of bytes written or -1
            //  if an error occurs
            nResult = Socket.WriteTo( strMessage, strHostAddress, nHostPort ); 
            if ( nResult == -1 ) 
            { 
                MessageBox.Show( Socket.LastErrorString ); 
                return; 
            } 
            
            UpdateListBox( string.Format( "Sent {0} bytes of data to {1}:{2}", nResult, strHostAddress, nHostPort ) ); 
        } 
        
        private void Socket_OnRead( object sender, System.EventArgs e ) 
        { 
            string strBuffer = string.Empty; 
            string strHostAddress = string.Empty; 
            int nHostPort = 0; 
            int nResult = 0; 
            
            //  The OnRead event will fire whenever the remote host echoes back the datagram
            //  that we sent. The ReadFrom method will read the datagram, storing the contents
            //  in the specified buffer, along with the address and port number of the peer
            //  that sent the datagram.
            // 
            //  Note that it's possible for ReadFrom to fail with errorConnectionReset,
            //  indicating that the address is valid but the port is unreachable.
            nResult = Socket.ReadFrom( ref strBuffer, 1024, ref strHostAddress, ref nHostPort ); 
            if ( nResult == -1 ) 
            { 
                UpdateListBox( string.Format( "Error {0}: {1}", Socket.LastError, Socket.LastErrorString ) ); 
                return; 
            } 
            
            UpdateListBox( string.Format( "Received {0} bytes of data from {1}:{2} [{3}]", nResult, strHostAddress, nHostPort, strBuffer ) ); 
        } 
        
    } 
    
    
} 
