// SocketWrench 10
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using SocketTools; 

namespace UdpListener
{
    public class Form1 : System.Windows.Forms.Form 
    { 
        private SocketTools.SocketWrench Socket = new SocketTools.SocketWrench(); 
        
        #region 'Windows Form Designer generated code' 
        
        public Form1() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
            
            // Add any initialization after the InitializeComponent() call
            if ( !( Socket.Initialize() ) ) 
            { 
                MessageBox.Show( "Unable to initialize SocketWrench component" ); 
                System.Environment.Exit( 0 ); 
            } 
		
			// Add handler for OnRead event
			Socket.OnRead += new System.EventHandler( Socket_OnRead ); 
		} 
        
        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool disposing ) 
        { 
            if ( disposing ) 
            { 
                if ( !( ( components == null ) ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.  
        // Do not modify it using the code editor.
        internal System.Windows.Forms.Button Button1; 
        internal System.Windows.Forms.ListBox ListBox1; 
        internal System.Windows.Forms.TextBox TextBox2; 
        internal System.Windows.Forms.Label Label2; 
        internal System.Windows.Forms.TextBox TextBox1; 
        internal System.Windows.Forms.Label Label1; 

        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.Button1 = new System.Windows.Forms.Button(); 
            this.ListBox1 = new System.Windows.Forms.ListBox(); 
            this.TextBox2 = new System.Windows.Forms.TextBox(); 
            this.Label2 = new System.Windows.Forms.Label(); 
            this.TextBox1 = new System.Windows.Forms.TextBox(); 
            this.Label1 = new System.Windows.Forms.Label(); 
            this.SuspendLayout(); 
            // 
            // Button1
            // 
            this.Button1.Location = new System.Drawing.Point( 153, 190 ); 
            this.Button1.Name = "Button1"; 
            this.Button1.Size = new System.Drawing.Size( 90, 30 ); 
            this.Button1.TabIndex = 5; 
            this.Button1.Text = "Start"; 
            // 
            // ListBox1
            // 
            this.ListBox1.HorizontalScrollbar = true; 
            this.ListBox1.Location = new System.Drawing.Point( 17, 40 ); 
            this.ListBox1.Name = "ListBox1"; 
            this.ListBox1.ScrollAlwaysVisible = true; 
            this.ListBox1.Size = new System.Drawing.Size( 360, 134 ); 
            this.ListBox1.TabIndex = 4; 
            this.ListBox1.TabStop = false; 
            // 
            // TextBox2
            // 
            this.TextBox2.Location = new System.Drawing.Point( 337, 12 ); 
            this.TextBox2.Name = "TextBox2"; 
            this.TextBox2.Size = new System.Drawing.Size( 40, 20 ); 
            this.TextBox2.TabIndex = 3; 
            this.TextBox2.Text = "7"; 
            // 
            // Label2
            // 
            this.Label2.Location = new System.Drawing.Point( 301, 14 ); 
            this.Label2.Name = "Label2"; 
            this.Label2.Size = new System.Drawing.Size( 30, 16 ); 
            this.Label2.TabIndex = 2; 
            this.Label2.Text = "Port:"; 
            // 
            // TextBox1
            // 
            this.TextBox1.Location = new System.Drawing.Point( 81, 12 ); 
            this.TextBox1.Name = "TextBox1"; 
            this.TextBox1.Size = new System.Drawing.Size( 200, 20 ); 
            this.TextBox1.TabIndex = 1; 
            this.TextBox1.Text = "127.0.0.1"; 
            // 
            // Label1
            // 
            this.Label1.Location = new System.Drawing.Point( 17, 14 ); 
            this.Label1.Name = "Label1"; 
            this.Label1.Size = new System.Drawing.Size( 60, 16 ); 
            this.Label1.TabIndex = 0; 
            this.Label1.Text = "Address:"; 
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 ); 
            this.ClientSize = new System.Drawing.Size( 394, 232 ); 
            this.Controls.Add( this.Button1 ); 
            this.Controls.Add( this.ListBox1 ); 
            this.Controls.Add( this.TextBox2 ); 
            this.Controls.Add( this.Label2 ); 
            this.Controls.Add( this.TextBox1 ); 
            this.Controls.Add( this.Label1 ); 
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog; 
            this.MaximizeBox = false; 
            this.Name = "Form1"; 
            this.Text = "UDP Listener Example"; 
            this.ResumeLayout( false ); 
            
            // events handled by Button1_Click
            Button1.Click += new System.EventHandler( Button1_Click ); 
        } 
        
		[STAThread]
		public static void Main() { Application.Run( new Form1() ); }
        #endregion 
        
        private void UpdateListBox( string message ) 
        { 
            ListBox1.Items.Add( message ); 
            ListBox1.SelectedIndex = ListBox1.Items.Count - 1; 
            ListBox1.ClearSelected(); 
        } 
        
        private void Button1_Click( System.Object sender, System.EventArgs e ) 
        { 
            string strLocalAddress = null; 
            int nLocalPort = 0; 
            
            strLocalAddress = TextBox1.Text.Trim(); 
            if ( strLocalAddress.Length == 0 ) 
            { 
                strLocalAddress = "0.0.0.0"; 
            } 
            
            nLocalPort = Int32.Parse( TextBox2.Text ); 
            if ( nLocalPort < 1 | nLocalPort > 65535 ) 
            { 
                MessageBox.Show( "Please specify a valid local port number" ); 
                return; 
            } 
            
            //  If the Handle property is -1, this means that the UDP socket has not been
            //  created. Initialize the socket properties and create a datagram socket
            //  using the Bind method. By setting Blocking to false, the OnRead event will
            //  be raised when a remote host sends us a datagram.
            if ( Socket.Handle == -1 ) 
            { 
                Socket.Protocol = SocketTools.SocketWrench.SocketProtocol.socketDatagram; 
                Socket.Blocking = false; 
                
                //  Bind to the specified IP address and port number
                if ( !( Socket.Bind( strLocalAddress, nLocalPort ) ) ) 
                { 
                    MessageBox.Show( Socket.LastErrorString ); 
                    return; 
                } 
                Button1.Text = "Stop"; 
                UpdateListBox( string.Format( "Started listening for datagrams on {0}:{1}", strLocalAddress, nLocalPort ) ); 
            } 
            else 
            { 
                //  Close the datagram socket using the Disconnect method
                Socket.Disconnect(); 
                Button1.Text = "Start"; 
                UpdateListBox( "Stopped listening for datagrams" ); 
            } 
            
        } 
        
        private void Socket_OnRead( object sender, System.EventArgs e ) 
        { 
            string strPeerAddress = string.Empty; 
            int nPeerPort = 0; 
            byte[] msgBuffer = new byte[ 8193 ]; 
            int nBytesRead = 0; 
            int nBytesWritten = 0; 
            
            //  The OnRead event will fire whenever a remote host sends a datagram to
            //  us on the port number that was specified. In this example, we limit
            //  the size of the datagram to 8K, but this could be any value up to 64K
            
            //  Initialize the contents of the byte array 
            Array.Clear( msgBuffer, 0, 8192 ); 
            
            //  Read the datagram that was sent to us; if the datagram is larger than
            //  the maxiumum size of our buffer, the remaining data is discarded
            nBytesRead = Socket.ReadFrom( msgBuffer, 8192, ref strPeerAddress, ref nPeerPort ); 
            if ( nBytesRead == -1 ) 
            { 
                UpdateListBox( string.Format( "Error {0}: {1}", Socket.LastError, Socket.LastErrorString ) ); 
                return; 
            } 
            
            if ( nBytesRead > 0 ) 
            { 
                //  Echo the datagram back to the remote host that sent it to us
                nBytesWritten = Socket.WriteTo( msgBuffer, nBytesRead, strPeerAddress, nPeerPort ); 
                if ( nBytesWritten == -1 ) 
                { 
                    UpdateListBox( string.Format( "Error {0}: {1}", Socket.LastError, Socket.LastErrorString ) ); 
                    return; 
                } 
            } 
            
            UpdateListBox( string.Format( "Echoed {0} bytes of data to {1}:{2}", nBytesWritten, strPeerAddress, nPeerPort ) ); 
        } 
    } 
} 
