'   SocketTools 10 .NET Edition
'   Copyright 2023 Catalyst Development Corporation
'   All rights reserved
'
'   This file is licensed to you pursuant to the terms of the
'   product license agreement included with the original software,
'   and is protected by copyright law and international treaties.
'   Unauthorized reproduction or distribution may result in severe
'   criminal penalties.
'
Option Strict Off
Option Explicit On 

Imports SocketTools.SshClient
Imports SocketTools.Terminal

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "
    Dim WithEvents SshClient1 As New SocketTools.SshClient

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        If Not SshClient1.Initialize() Then
            MsgBox("Unable to initialize SocketTools component", MsgBoxStyle.Exclamation)
            End
        End If

        If Not Terminal1.Initialize() Then
            MsgBox("Unable to initialize SocketTools component", MsgBoxStyle.Exclamation)
            End
        End If
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Terminal1 As SocketTools.Terminal
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem5 As System.Windows.Forms.MenuItem
    Friend WithEvents Timer1 As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.Terminal1 = New SocketTools.Terminal
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.MenuItem5 = New System.Windows.Forms.MenuItem
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.Timer1 = New System.Windows.Forms.Timer(Me.components)
        Me.SuspendLayout()
        '
        'Terminal1
        '
        Me.Terminal1.Attributes = SocketTools.Terminal.TerminalAttributes.Normal
        Me.Terminal1.AutoRefresh = True
        Me.Terminal1.AutoSelect = True
        Me.Terminal1.AutoSize = True
        Me.Terminal1.AutoWrap = True
        Me.Terminal1.BackColor = System.Drawing.Color.Black
        Me.Terminal1.Bell = True
        Me.Terminal1.BoldColor = System.Drawing.Color.White
        Me.Terminal1.Caret = SocketTools.Terminal.TerminalCaret.Underline
        Me.Terminal1.Columns = 80
        Me.Terminal1.CursorX = 0
        Me.Terminal1.CursorY = 0
        Me.Terminal1.Emulation = SocketTools.Terminal.TerminalEmulation.ANSI
        Me.Terminal1.Font = New System.Drawing.Font("Courier New", 9.0!)
        Me.Terminal1.ForeColor = System.Drawing.Color.LightGray
        Me.Terminal1.LastError = SocketTools.Terminal.ErrorCode.errorNone
        Me.Terminal1.Location = New System.Drawing.Point(0, 0)
        Me.Terminal1.Name = "Terminal1"
        Me.Terminal1.NewLine = SocketTools.Terminal.TerminalNewLine.CRLF
        Me.Terminal1.Rows = 25
        Me.Terminal1.ScrollBars = SocketTools.Terminal.TerminalScrollBars.Both
        Me.Terminal1.SelLength = 0
        Me.Terminal1.SelStart = 0
        Me.Terminal1.Size = New System.Drawing.Size(557, 400)
        Me.Terminal1.TabIndex = 0
        Me.Terminal1.ThrowError = False
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem2, Me.MenuItem3, Me.MenuItem5, Me.MenuItem4})
        Me.MenuItem1.Text = "Connection"
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 0
        Me.MenuItem2.Text = "Connect"
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 1
        Me.MenuItem3.Text = "Disconnect"
        '
        'MenuItem5
        '
        Me.MenuItem5.Index = 2
        Me.MenuItem5.Text = "-"
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 3
        Me.MenuItem4.Text = "Exit"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(557, 400)
        Me.Controls.Add(Me.Terminal1)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "SocketTools Terminal Example"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MenuItem2.Enabled = True  ' Connect
        MenuItem3.Enabled = False ' Disconnect
    End Sub

    Private Sub Form1_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        Me.BringToFront()
    End Sub

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        ' If a connection has been established, make sure that the user
        ' really wants to terminate the connection
        If SshClient1.IsConnected Then
            If MsgBox("Are you sure you wish to disconnect?", MsgBoxStyle.Question Or MsgBoxStyle.YesNo) = MsgBoxResult.No Then
                e.Cancel = True
            End If
        End If
    End Sub

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        ' Disconnect any active session. Note that this is safe to call
        ' even if no connection has been established.
        SshClient1.Disconnect()
    End Sub

    Private Sub MenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem2.Click
        Dim Connection As New Form2

        ' Ask the user for connection information such as the host name,
        ' port number and emulation type that is preferred
        Connection.HostName = SshClient1.HostName
        Connection.RemotePort = SshClient1.RemotePort
        Connection.UserName = SshClient1.UserName
        Connection.Password = SshClient1.Password
        Connection.Emulation = Terminal1.Emulation
        Connection.ShowDialog()

        If Connection.Canceled Then
            Exit Sub
        End If

        Me.BringToFront()

        ' Initialize the SshClient1 class instance with the information
        ' provided by the user and set it into non-blocking (asynchronous)
        ' mode. This is important because this is a single-threaded
        ' application with everything running in the UI thread. The
        ' asynchronous event notifications allow the application to
        ' remain responsive to user.
        SshClient1.HostName = Connection.HostName
        SshClient1.RemotePort = Connection.RemotePort
        SshClient1.UserName = Connection.UserName
        SshClient1.Password = Connection.Password
        SshClient1.Blocking = False

        ' Set the terminal emulation type for the Telnet session;
        ' for UNIX based systems, this is the value that the TERM
        ' environment variable will be set to when the user logs in
        Select Case Connection.Emulation
            Case SocketTools.Terminal.TerminalEmulation.None
                SshClient1.Terminal = "dumb"
            Case SocketTools.Terminal.TerminalEmulation.ANSI
                SshClient1.Terminal = "ansi"
            Case SocketTools.Terminal.TerminalEmulation.VT100
                SshClient1.Terminal = "vt100"
            Case SocketTools.Terminal.TerminalEmulation.VT220
                SshClient1.Terminal = "vt220"
        End Select

        ' Set a timeout period of 20 seconds; if the connection
        ' hasn't completed by then, cancel the connection attempt
        ' and let the user know
        Timer1.Interval = 20000 ' 20 seconds
        Timer1.Enabled = True

        ' Disable the Connect menu item
        MenuItem2.Enabled = False

        ' Start the connection process to the server. Because a
        ' non-blocking connection is being used, this method will
        ' return immediately, and when the connection has completed
        ' the OnConnect event will fire.
        If Not SshClient1.Connect() Then
            MsgBox(SshClient1.LastErrorString, MsgBoxStyle.Exclamation)
            Exit Sub
        End If

        ' Update the terminal emulation and clear the display
        Terminal1.Emulation = Connection.Emulation
        Terminal1.Clear()
    End Sub

    Private Sub MenuItem3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem3.Click
        ' Disconnect from the server and update the menu items
        SshClient1.Disconnect()
        MenuItem2.Enabled = True
        MenuItem3.Enabled = False
        Timer1.Enabled = False
    End Sub

    Private Sub MenuItem4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem4.Click
        Me.Close()
    End Sub

    Private Sub SshClient1_OnConnect(ByVal sender As Object, ByVal e As System.EventArgs) Handles SshClient1.OnConnect
        ' A connection with the server has been established, so
        ' update the menu items. Next, an OnRead event should fire
        ' that typically contains the login prompt for the user.
        Debug.WriteLine("Connection established with " + SshClient1.HostName + " on port " + SshClient1.RemotePort.ToString())
        MenuItem2.Enabled = False
        MenuItem3.Enabled = True
        Timer1.Enabled = False
    End Sub

    Private Sub SshClient1_OnDisconnect(ByVal sender As Object, ByVal e As System.EventArgs) Handles SshClient1.OnDisconnect
        ' The remote host as terminated its connection with the client;
        ' this could be the result of the user logging out, or it could
        ' be for some other reason, such as the server rebooting or
        ' shutting down.
        Debug.WriteLine("Connection closed by remote host")
        MsgBox("Remote host closed connection", MsgBoxStyle.Information)
        SshClient1.Disconnect()
        MenuItem2.Enabled = True
        MenuItem3.Enabled = False
    End Sub

    Private Sub SshClient1_OnRead(ByVal sender As Object, ByVal e As System.EventArgs) Handles SshClient1.OnRead
        ' The OnRead event is fired whenever data is available to read
        Dim Buffer(1024) As Byte
        Dim Length As Integer

        ' Read all of the available data; a loop is used to ensure
        ' that if there is a large amount of data returned by the
        ' server, all of it will be read and processed. If the
        ' return value from the Read method is zero, that means
        ' the remote host has closed its connection. If the value
        ' is -1, that means an error has occurred.
        ' Do
        Length = SshClient1.Read(Buffer, 1024)
        If Length > 0 Then
            Debug.WriteLine("Read " + Length.ToString() + " bytes of data from remote host")
            ' Write the data received to the virtual terminal display
            Terminal1.Write(Buffer, Length)
        End If
        'Loop Until Length < 1

        ' If the return value was -1 and the last error indicates any
        ' problem other than the operation would block, display the error.
        ' Note that errorOperationWouldBlock is a normal error for non-
        ' blocking connections. It means that all of the data has been read,
        ' and that the application should wait for another OnRead event to
        ' attempt to read more data. It should be considered an advisory
        ' error, not a fatal error. It's also possible to get errorConnectionClosed
        ' if the remote host terminates the connection while the OnRead event
        ' is being handled, and can be safely ignored.
        If Length = -1 Then
            Debug.WriteLine("Error " + SshClient1.LastError.ToString() + ": " + SshClient1.LastErrorString)
        End If
    End Sub

    Private Sub Terminal1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Terminal1.KeyPress
        ' The user has pressed a regular key, send that keypress to the
        ' remote host for processing
        If SshClient1.IsConnected Then
            SshClient1.Write(e.KeyChar)
        Else
            Beep()
        End If
    End Sub

    Private Sub Terminal1_KeyMapped(ByVal sender As Object, ByVal e As SocketTools.Terminal.KeyMappedEventArgs) Handles Terminal1.KeyMapped
        ' The user has pressed a special key, such as a function key or arrow
        ' key; send the escape sequence that is mapped to that special key to
        ' the remote host for processing. Note that the KeyMap property array
        ' can be used to specify custom escape sequences; the default escape
        ' sequences are based on the emulation type specified.
        If SshClient1.IsConnected Then
            SshClient1.Write(e.KeyValue)
        Else
            Beep()
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        SshClient1.Disconnect()
        MenuItem2.Enabled = True
        Timer1.Enabled = False
        MsgBox("Unable to establish a connection with the remote host", MsgBoxStyle.Exclamation)
    End Sub
End Class
