' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Strict Off
Option Explicit On 

Imports SocketTools
Imports SocketTools.SocketWrench

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private WithEvents Socket As New SocketTools.SocketWrench

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        If Not Socket.Initialize() Then
            MsgBox("Unable to initialize SocketWrench component", MsgBoxStyle.Exclamation, "Error")
            End
        End If
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents ListBox1 As System.Windows.Forms.ListBox
    Friend WithEvents TextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Button1 = New System.Windows.Forms.Button
        Me.ListBox1 = New System.Windows.Forms.ListBox
        Me.TextBox2 = New System.Windows.Forms.TextBox
        Me.Label2 = New System.Windows.Forms.Label
        Me.TextBox1 = New System.Windows.Forms.TextBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(153, 190)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(90, 30)
        Me.Button1.TabIndex = 5
        Me.Button1.Text = "Start"
        '
        'ListBox1
        '
        Me.ListBox1.HorizontalScrollbar = True
        Me.ListBox1.Location = New System.Drawing.Point(17, 40)
        Me.ListBox1.Name = "ListBox1"
        Me.ListBox1.ScrollAlwaysVisible = True
        Me.ListBox1.Size = New System.Drawing.Size(360, 134)
        Me.ListBox1.TabIndex = 4
        Me.ListBox1.TabStop = False
        '
        'TextBox2
        '
        Me.TextBox2.Location = New System.Drawing.Point(337, 12)
        Me.TextBox2.Name = "TextBox2"
        Me.TextBox2.Size = New System.Drawing.Size(40, 20)
        Me.TextBox2.TabIndex = 3
        Me.TextBox2.Text = "7"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(301, 14)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(30, 16)
        Me.Label2.TabIndex = 2
        Me.Label2.Text = "Port:"
        '
        'TextBox1
        '
        Me.TextBox1.Location = New System.Drawing.Point(81, 12)
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.Size = New System.Drawing.Size(200, 20)
        Me.TextBox1.TabIndex = 1
        Me.TextBox1.Text = "127.0.0.1"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(17, 14)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(60, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Address:"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(394, 232)
        Me.Controls.Add(Me.Button1)
        Me.Controls.Add(Me.ListBox1)
        Me.Controls.Add(Me.TextBox2)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.TextBox1)
        Me.Controls.Add(Me.Label1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MaximizeBox = False
        Me.Name = "Form1"
        Me.Text = "UDP Listener Example"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub UpdateListBox(ByVal message As String)
        ListBox1.Items.Add(message)
        ListBox1.SelectedIndex = ListBox1.Items.Count - 1
        ListBox1.ClearSelected()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim strLocalAddress As String
        Dim nLocalPort As Integer

        strLocalAddress = TextBox1.Text.Trim()
        If strLocalAddress.Length = 0 Then
            strLocalAddress = "0.0.0.0"
        End If

        nLocalPort = Int32.Parse(TextBox2.Text)
        If nLocalPort < 1 Or nLocalPort > 65535 Then
            MsgBox("Please specify a valid local port number", MsgBoxStyle.Exclamation, "Error")
            Exit Sub
        End If

        ' If the Handle property is -1, this means that the UDP socket has not been
        ' created. Initialize the socket properties and create a datagram socket
        ' using the Bind method. By setting Blocking to false, the OnRead event will
        ' be raised when a remote host sends us a datagram.
        If Socket.Handle = -1 Then
            Socket.Protocol = SocketProtocol.socketDatagram
            Socket.Blocking = False

            ' Bind to the specified IP address and port number
            If Not Socket.Bind(strLocalAddress, nLocalPort) Then
                MsgBox(Socket.LastErrorString, MsgBoxStyle.Exclamation, "Error")
                Exit Sub
            End If
            Button1.Text = "Stop"
            UpdateListBox(String.Format("Started listening for datagrams on {0}:{1}", strLocalAddress, nLocalPort))
        Else
            ' Close the datagram socket using the Disconnect method
            Socket.Disconnect()
            Button1.Text = "Start"
            UpdateListBox("Stopped listening for datagrams")
        End If

    End Sub

    Private Sub Socket_OnRead(ByVal sender As Object, ByVal e As System.EventArgs) Handles Socket.OnRead
        Dim strPeerAddress As String = String.Empty
        Dim nPeerPort As Integer = 0
        Dim msgBuffer(8192) As Byte
        Dim nBytesRead As Integer
        Dim nBytesWritten As Integer

        ' The OnRead event will fire whenever a remote host sends a datagram to
        ' us on the port number that was specified. In this example, we limit
        ' the size of the datagram to 8K, but this could be any value up to 64K

        ' Initialize the contents of the byte array 
        Array.Clear(msgBuffer, 0, 8192)

        ' Read the datagram that was sent to us; if the datagram is larger than
        ' the maxiumum size of our buffer, the remaining data is discarded
        nBytesRead = Socket.ReadFrom(msgBuffer, 8192, strPeerAddress, nPeerPort)
        If nBytesRead = -1 Then
            UpdateListBox(String.Format("Error {0}: {1}", Socket.LastError, Socket.LastErrorString))
            Exit Sub
        End If

        If nBytesRead > 0 Then
            ' Echo the datagram back to the remote host that sent it to us
            nBytesWritten = Socket.WriteTo(msgBuffer, nBytesRead, strPeerAddress, nPeerPort)
            If nBytesWritten = -1 Then
                UpdateListBox(String.Format("Error {0}: {1}", Socket.LastError, Socket.LastErrorString))
                Exit Sub
            End If
        End If

        UpdateListBox(String.Format("Echoed {0} bytes of data to {1}:{2}", nBytesWritten, strPeerAddress, nPeerPort))
    End Sub
End Class
