' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'

Option Strict Off
Option Explicit On

Imports VB = Microsoft.VisualBasic
Imports SocketTools.SocketWrench.SocketProtocol
Imports SocketTools.SocketWrench.SocketOptions
Imports SocketTools.SocketWrench.ErrorCode

Friend Class formMain
    Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub
    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents Command1 As System.Windows.Forms.Button
    Public WithEvents Label2 As System.Windows.Forms.Label
    Public WithEvents Label1 As System.Windows.Forms.Label
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.Command1 = New System.Windows.Forms.Button
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label1 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'Command1
        '
        Me.Command1.BackColor = System.Drawing.SystemColors.Control
        Me.Command1.Cursor = System.Windows.Forms.Cursors.Default
        Me.Command1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Command1.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Command1.Location = New System.Drawing.Point(99, 112)
        Me.Command1.Name = "Command1"
        Me.Command1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Command1.Size = New System.Drawing.Size(81, 29)
        Me.Command1.TabIndex = 0
        Me.Command1.Text = "Query"
        '
        'Label2
        '
        Me.Label2.BackColor = System.Drawing.SystemColors.Control
        Me.Label2.Cursor = System.Windows.Forms.Cursors.Default
        Me.Label2.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Label2.Location = New System.Drawing.Point(8, 64)
        Me.Label2.Name = "Label2"
        Me.Label2.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Label2.Size = New System.Drawing.Size(269, 33)
        Me.Label2.TabIndex = 2
        Me.Label2.Text = "You should be running the ServerIP example program, which will respond to this br" & _
        "oadcast."
        '
        'Label1
        '
        Me.Label1.BackColor = System.Drawing.SystemColors.Control
        Me.Label1.Cursor = System.Windows.Forms.Cursors.Default
        Me.Label1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Label1.Location = New System.Drawing.Point(8, 12)
        Me.Label1.Name = "Label1"
        Me.Label1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Label1.Size = New System.Drawing.Size(270, 45)
        Me.Label1.TabIndex = 1
        '
        'formMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.ClientSize = New System.Drawing.Size(289, 152)
        Me.Controls.Add(Me.Command1)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Location = New System.Drawing.Point(3, 29)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "formMain"
        Me.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "QueryIP"
        Me.ResumeLayout(False)

    End Sub
#End Region
    Private WithEvents Socket As New SocketTools.SocketWrench

    '
    ' Configuration values for the UDP client
    '
    Private Const queryBroadcast As String = "255.255.255.255" ' Local broadcast address
    Private Const queryPort As Integer = 8195 ' Port number
    Private Const queryTimeout As Integer = 5 ' Timeout period (seconds)
    Private Const queryResponse As Integer = 128 ' Maximum datagram size

    Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click
        Dim strAddress As String = ""
        Dim nPort As Integer = 0

        Command1.Enabled = False

        If GetServerAddress(strAddress, nPort) Then
            MsgBox("The server requests that you connect to address" & vbCrLf & strAddress & " on port " & nPort, MsgBoxStyle.Information, "Success")
        Else
            MsgBox("Unable to determine server address", MsgBoxStyle.Exclamation, "Error")
        End If

        Command1.Enabled = True
    End Sub

    Private Function GetServerAddress(ByRef strAddress As String, ByRef nPort As Integer) As Boolean
        Dim strBuffer As String
        Dim nIndex As Integer

        GetServerAddress = False

        ' Create a UDP socket and specify a broadcast IP address;
        ' note that the Connect method doesn't actually create a
        ' connection like it does with TCP, it simply creates the
        ' socket and sets the default address and port number

        ' If Not Socket.Bind(queryBroadcast, queryPort, socketDatagram, socketOptionBroadcast) Then
        'Exit Function
        'End If

        If Not Socket.Connect(queryBroadcast, queryPort, socketDatagram, queryTimeout, optionBroadcast) Then
            Exit Function
        End If

        ' Create a small datagram that just contains our local IP
        ' address and broadcast it over our local network

        strBuffer = Socket.LocalAddress
        If Socket.Write(strBuffer) = -1 Then Exit Function

        strBuffer = ""
        If Socket.Read(strBuffer, queryResponse) = -1 Then Exit Function

        ' The response from the server should be a string in the
        ' form of aaa.bbb.ccc.ddd:nnnn specifying both the IP
        ' address in dot-notation and the port number to connect to

        nIndex = InStr(strBuffer, ":")
        If nIndex = -1 Then Exit Function

        ' Extract the IP address from the response and make sure
        ' that it looks like a valid address

        strAddress = VB.Left(strBuffer, nIndex - 1)
        If Not ValidAddress(strAddress) Then Exit Function ' Malformed address

        ' Extract the port number from the response and make sure
        ' that it's a valid port number

        nPort = Val(VB.Right(strBuffer, Len(strBuffer) - nIndex))
        If nPort < 1 Or nPort > 65535 Then Exit Function ' Malformed port

        GetServerAddress = True
    End Function

    Private Function ValidAddress(ByRef strAddress As String) As Boolean
        Dim strValue() As String
        Dim strResult As String
        Dim nValue As Integer
        Dim nIndex As Integer

        ValidAddress = False

        strResult = ""

        strValue = Split(strAddress, ".")
        If UBound(strValue) <> 3 Then Exit Function

        For nIndex = 0 To 3
            nValue = Val(strValue(nIndex))
            If nValue < 0 Or nValue > 255 Then Exit Function
            strResult = strResult & CStr(nValue)
            If nIndex < 3 Then strResult = strResult & "."
        Next

        If strResult <> "0.0.0.0" And strResult <> "255.255.255.255" Then
            strAddress = strResult
            ValidAddress = True
        End If
    End Function

    Private Sub formMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Label1.Text = "This will broadcast a datagram over the local network " & "on port " & queryPort & " in an attempt to discover the " & "IP address and port number for a server."
    End Sub
End Class