' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.

Option Strict Off
Option Explicit On

Friend Class MainForm
    Inherits System.Windows.Forms.Form
    Private WebLocation1 As New SocketTools.WebLocation()

    Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click
        Me.Cursor = System.Windows.Forms.Cursors.WaitCursor
        Command1.Enabled = False
        Command2.Enabled = False

        If WebLocation1.LastUpdate > 0 Then
            Status.Text = "Location was last updated " & WebLocation1.LastUpdate & " seconds ago"
        End If

        If WebLocation1.Update() Then
            textLocationId.Text = WebLocation1.LocationId
            textIPAddress.Text = WebLocation1.IPAddress
            textASN.Text = CStr(WebLocation1.ASNumber)
            textOrganization.Text = WebLocation1.Organization
            textRegion.Text = WebLocation1.RegionName & " (" & WebLocation1.RegionCode & ")"
            textCountry.Text = WebLocation1.CountryName & " (" & WebLocation1.CountryAlpha & ")"
            textSubdivision.Text = WebLocation1.Subdivision & " (" & WebLocation1.SubdivisionCode & ")"
            textCity.Text = WebLocation1.CityName
            textPostalCode.Text = WebLocation1.PostalCode
            textTimezone.Text = WebLocation1.Timezone & " (" & WebLocation1.TzShortName & ")"
            textLocalTime.Text = WebLocation1.LocalTime
            textCoordinates.Text = WebLocation1.Coordinates
            textLongLat.Text = WebLocation1.Longitude & "/" & WebLocation1.Latitude
        Else
            MsgBox(WebLocation1.LastErrorString, MsgBoxStyle.Exclamation)
        End If

        Command2.Enabled = True
        Command1.Enabled = True
        Command1.Focus()
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Refresh()
    End Sub

    Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click
        Me.Close()
    End Sub
End Class