// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.VisualBasic;
using SocketTools;

namespace Terminal
{
	public class Form1 : System.Windows.Forms.Form 
    { 
        #region ' Windows Form Designer generated code '
		[DllImport("Kernel32.dll")]
		private static extern int MessageBeep( int nType );
		
		public SocketTools.TelnetClient Telnet1 = new SocketTools.TelnetClient(); 
        
        public Form1() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
            
            // Add any initialization after the InitializeComponent() call
            if ( !( Telnet1.Initialize() ) ) 
            { 
				MessageBox.Show("Unable to initialize SocketTools component");
                System.Environment.Exit( 0 ); 
            } 

			// Add the event handlers for the Telnet1 object
			Telnet1.OnConnect += new EventHandler(Telnet1_OnConnect);
			Telnet1.OnDisconnect += new EventHandler(Telnet1_OnDisconnect);            
			Telnet1.OnRead += new EventHandler(Telnet1_OnRead);
			
            if ( !( Terminal1.Initialize() ) ) 
            { 
				MessageBox.Show("Unable to initialize SocketTools component");
				System.Environment.Exit( 0 ); 
            } 
        } 
        
        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool disposing ) 
        { 
            if ( disposing ) 
            { 
                if ( !( ( components == null ) ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( disposing ); 
        } 
        
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.  
        // Do not modify it using the code editor.
        internal SocketTools.Terminal Terminal1; 
        internal System.Windows.Forms.MainMenu MainMenu1; 
        internal System.Windows.Forms.MenuItem MenuItem1; 
        internal System.Windows.Forms.MenuItem MenuItem2; 
        internal System.Windows.Forms.MenuItem MenuItem3; 
        internal System.Windows.Forms.MenuItem MenuItem4; 
        internal System.Windows.Forms.MenuItem MenuItem5; 
        internal System.Windows.Forms.Timer Timer1; 

        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
			this.components = new System.ComponentModel.Container();
			this.Terminal1 = new SocketTools.Terminal();
			this.MainMenu1 = new System.Windows.Forms.MainMenu();
			this.MenuItem1 = new System.Windows.Forms.MenuItem();
			this.MenuItem2 = new System.Windows.Forms.MenuItem();
			this.MenuItem3 = new System.Windows.Forms.MenuItem();
			this.MenuItem5 = new System.Windows.Forms.MenuItem();
			this.MenuItem4 = new System.Windows.Forms.MenuItem();
			this.Timer1 = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// Terminal1
			// 
			this.Terminal1.Attributes = SocketTools.Terminal.TerminalAttributes.Normal;
			this.Terminal1.AutoRefresh = true;
			this.Terminal1.AutoSelect = true;
			this.Terminal1.AutoSize = true;
			this.Terminal1.AutoWrap = true;
			this.Terminal1.BackColor = System.Drawing.Color.Black;
			this.Terminal1.Bell = true;
			this.Terminal1.BoldColor = System.Drawing.Color.White;
			this.Terminal1.Caret = SocketTools.Terminal.TerminalCaret.Underline;
			this.Terminal1.Columns = 80;
			this.Terminal1.CursorX = 0;
			this.Terminal1.CursorY = 0;
			this.Terminal1.Emulation = SocketTools.Terminal.TerminalEmulation.ANSI;
			this.Terminal1.Font = new System.Drawing.Font("Courier New", 9F);
			this.Terminal1.ForeColor = System.Drawing.Color.LightGray;
			this.Terminal1.LastError = SocketTools.Terminal.ErrorCode.errorNone;
			this.Terminal1.Location = new System.Drawing.Point(0, 0);
			this.Terminal1.Name = "Terminal1";
			this.Terminal1.NewLine = SocketTools.Terminal.TerminalNewLine.CRLF;
			this.Terminal1.Rows = 25;
			this.Terminal1.ScrollBars = SocketTools.Terminal.TerminalScrollBars.Both;
			this.Terminal1.SelLength = 0;
			this.Terminal1.SelStart = 0;
			this.Terminal1.Size = new System.Drawing.Size(557, 400);
			this.Terminal1.TabIndex = 0;
			this.Terminal1.ThrowError = false;
			this.Terminal1.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.Terminal1_KeyPress);
			this.Terminal1.KeyMapped += new SocketTools.Terminal.KeyMappedEventHandler(this.Terminal1_KeyMapped);
			// 
			// MainMenu1
			// 
			this.MainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] { this.MenuItem1});
			// 
			// MenuItem1
			// 
			this.MenuItem1.Index = 0;
			this.MenuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
				this.MenuItem2,
				this.MenuItem3,
				this.MenuItem5,
				this.MenuItem4});
				
			this.MenuItem1.Text = "Connection";
			// 
			// MenuItem2
			// 
			this.MenuItem2.Index = 0;
			this.MenuItem2.Text = "Connect";
			this.MenuItem2.Click += new System.EventHandler(this.MenuItem2_Click);
			// 
			// MenuItem3
			// 
			this.MenuItem3.Index = 1;
			this.MenuItem3.Text = "Disconnect";
			this.MenuItem3.Click += new System.EventHandler(this.MenuItem3_Click);
			// 
			// MenuItem5
			// 
			this.MenuItem5.Index = 2;
			this.MenuItem5.Text = "-";
			// 
			// MenuItem4
			// 
			this.MenuItem4.Index = 3;
			this.MenuItem4.Text = "Exit";
			this.MenuItem4.Click += new System.EventHandler(this.MenuItem4_Click);
			// 
			// Timer1
			// 
			this.Timer1.Tick += new System.EventHandler(this.Timer1_Tick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(557, 400);
			this.Controls.Add(this.Terminal1);
			this.Menu = this.MainMenu1;
			this.Name = "Form1";
			this.Text = "SocketTools Terminal Example";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			this.ResumeLayout(false);
		} 

		[STAThread]
		public static void Main()
		{
            Application.EnableVisualStyles();
            Application.DoEvents();
			Application.Run( new Form1() );
		}
		#endregion 
        
        private void Form1_Load( object sender, System.EventArgs e ) 
        { 
            MenuItem2.Enabled = true; //  Connect
            MenuItem3.Enabled = false; //  Disconnect
        } 
        
        private void Form1_Closing( object sender, System.ComponentModel.CancelEventArgs e ) 
        { 
            //  If a connection has been established, make sure that the user
            //  really wants to terminate the connection
            if ( Telnet1.IsConnected ) 
            { 
				if ( MessageBox.Show("Are you sure you want to disconnect?", "Terminal",
					 MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No )
				{
                    e.Cancel = true; 
                } 
            } 
        } 
        
        private void Form1_Closed( object sender, System.EventArgs e ) 
        { 
            //  Disconnect any active session. Note that this is safe to call
            //  even if no connection has been established.
            Telnet1.Disconnect(); 
        } 
        
        private void MenuItem2_Click( System.Object sender, System.EventArgs e ) 
        { 
            Form2 Connection = new Form2(); 
            
            //  Ask the user for connection information such as the host name,
            //  port number and emulation type that is preferred
            Connection.HostName = Telnet1.HostName; 
            Connection.RemotePort = Telnet1.RemotePort; 
            Connection.Emulation = Terminal1.Emulation; 
            Connection.ShowDialog(); 
            
            if ( Connection.Canceled ) 
            { 
                return; 
            } 
            
            //  Initialize the Telnet1 class instance with the information
            //  provided by the user and set it into non-blocking (asynchronous)
            //  mode. This is important because this is a single-threaded
            //  application with everything running in the UI thread. The
            //  asynchronous event notifications allow the application to
            //  remain responsive to user.
            Telnet1.HostName = Connection.HostName; 
            Telnet1.RemotePort = Connection.RemotePort; 
            Telnet1.Blocking = false; 
            
            //  Set the terminal emulation type for the Telnet session;
            //  for UNIX based systems, this is the value that the TERM
            //  environment variable will be set to when the user logs in
            switch ( Connection.Emulation ) 
            {
                case SocketTools.Terminal.TerminalEmulation.None:
                    Telnet1.Terminal = "dumb"; 
                    break;
                case SocketTools.Terminal.TerminalEmulation.ANSI:
                    Telnet1.Terminal = "ansi"; 
                    break;
                case SocketTools.Terminal.TerminalEmulation.VT100:
                    Telnet1.Terminal = "vt100"; 
                    break;
                case SocketTools.Terminal.TerminalEmulation.VT220:
                    Telnet1.Terminal = "vt220"; 
                    break;
            }
            
            //  Set a timeout period of 20 seconds; if the connection
            //  hasn't completed by then, cancel the connection attempt
            //  and let the user know
            Timer1.Interval = 20000; //  20 seconds
            Timer1.Enabled = true; 
            
            //  Disable the Connect menu item
            MenuItem2.Enabled = false; 
            
            //  Start the connection process to the server. Because a
            //  non-blocking connection is being used, this method will
            //  return immediately, and when the connection has completed
            //  the OnConnect event will fire.
            if ( !( Telnet1.Connect() ) ) 
            { 
				MessageBox.Show( Telnet1.LastErrorString );
                return; 
            } 
            
            //  Update the terminal emulation and clear the display
            Terminal1.Emulation = Connection.Emulation; 
            Terminal1.Clear(); 
        } 
        
        private void MenuItem3_Click( System.Object sender, System.EventArgs e ) 
        { 
            //  Disconnect from the server and update the menu items
            Telnet1.Disconnect(); 
            MenuItem2.Enabled = true; 
            MenuItem3.Enabled = false; 
            Timer1.Enabled = false; 
        } 
        
        private void MenuItem4_Click( System.Object sender, System.EventArgs e ) 
        { 
            this.Close(); 
        } 
        
        private void Telnet1_OnConnect( object sender, System.EventArgs e ) 
        { 
            //  A connection with the server has been established, so
            //  update the menu items. Next, an OnRead event should fire
            //  that typically contains the login prompt for the user.
            Debug.WriteLine( "Connection established with " + Telnet1.HostName + " on port " + Telnet1.RemotePort.ToString() ); 
            MenuItem2.Enabled = false; 
            MenuItem3.Enabled = true; 
            Timer1.Enabled = false; 
        } 
        
        private void Telnet1_OnDisconnect( object sender, System.EventArgs e ) 
        { 
            //  The remote host as terminated its connection with the client;
            //  this could be the result of the user logging out, or it could
            //  be for some other reason, such as the server rebooting or
            //  shutting down.
            Debug.WriteLine( "Connection closed by remote host" ); 
            MessageBox.Show( "Remote host closed connection" ); 
            Telnet1.Disconnect(); 
            MenuItem2.Enabled = true; 
            MenuItem3.Enabled = false; 
        } 
        
        private void Telnet1_OnRead( object sender, System.EventArgs e ) 
        { 
            //  The OnRead event is fired whenever data is available to read
            byte[] Buffer = new byte[ 1025 ]; 
            int Length = 0; 
            
            //  Read all of the available data; a loop is used to ensure
            //  that if there is a large amount of data returned by the
            //  server, all of it will be read and processed. If the
            //  return value from the Read method is zero, that means
            //  the remote host has closed its connection. If the value
            //  is -1, that means an error has occurred.
            do 
            { 
                Length = Telnet1.Read( Buffer, 1024 ); 
                if ( Length > 0 ) 
                { 
                    Debug.WriteLine( "Read " + Length.ToString() + " bytes of data from remote host" ); 
                    //  Write the data received to the virtual terminal display
                    Terminal1.Write( Buffer, Length ); 
                } 
            } 
            while (  ! ( Length < 1 ) ); 
            
            //  If the return value was -1 and the last error indicates any
            //  problem other than the operation would block, display the error.
            //  Note that errorOperationWouldBlock is a normal error for non-
            //  blocking connections. It means that all of the data has been read,
            //  and that the application should wait for another OnRead event to
            //  attempt to read more data. It should be considered an advisory
            //  error, not a fatal error. It's also possible to get errorConnectionClosed
            //  if the remote host terminates the connection while the OnRead event
            //  is being handled, and can be safely ignored.
            if ( Length == -1 ) 
            { 
                Debug.WriteLine( "Error " + Telnet1.LastError.ToString() + ": " + Telnet1.LastErrorString ); 
            } 
        } 
        
        private void Terminal1_KeyPress( object sender, System.Windows.Forms.KeyPressEventArgs e ) 
        { 
            //  The user has pressed a regular key, send that keypress to the
            //  remote host for processing
            if ( Telnet1.IsConnected ) 
            { 
                Telnet1.Write( e.KeyChar ); 
            } 
            else 
            { 
                MessageBeep( -1 ); 
            } 
        } 
        
        private void Terminal1_KeyMapped( object sender, SocketTools.Terminal.KeyMappedEventArgs e ) 
        { 
            //  The user has pressed a special key, such as a function key or arrow
            //  key; send the escape sequence that is mapped to that special key to
            //  the remote host for processing. Note that the KeyMap property array
            //  can be used to specify custom escape sequences; the default escape
            //  sequences are based on the emulation type specified.
            if ( Telnet1.IsConnected ) 
            { 
                Telnet1.Write( e.KeyValue ); 
            } 
            else 
            { 
                MessageBeep( -1 ); 
            } 
        } 
        
        private void Timer1_Tick( object sender, System.EventArgs e ) 
        { 
            Telnet1.Disconnect(); 
			MenuItem2.Enabled = true;
			Timer1.Enabled = false; 
			MessageBox.Show( "Unable to establish a connection with the remote host" ); 
        } 
    } 
} 
