' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Strict Off
Option Explicit On

Module modOptions
    Private Const KEY_PRODUCT As String = "SocketTools Examples"

    Public g_strSenderName As String
    Public g_strSenderAddress As String
    Public g_strOrganization As String
    Public g_bRelayMessages As Boolean
    Public g_strRelayServer As String
    Public g_nRelayPort As Integer
    Public g_strUserName As String
    Public g_strPassword As String
    Public g_bAuthenticate As Boolean

    Sub LoadOptions()
        g_strSenderName = GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "SenderName")
        g_strSenderAddress = GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "SenderAddress")
        g_strOrganization = GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "Organization")
        g_bRelayMessages = CBool(GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayMessages", "True"))
        g_strRelayServer = GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayServer")
        g_nRelayPort = CInt(GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayPort", "25"))
        g_strUserName = GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "UserName")
        g_strPassword = "" ' Clear password
        g_bAuthenticate = False
    End Sub

    Sub SaveOptions()
        SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "SenderName", g_strSenderName)
        SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "SenderAddress", g_strSenderAddress)
        SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "Organization", g_strOrganization)
        SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayMessages", CStr(g_bRelayMessages))
        SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayServer", g_strRelayServer)
        SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayPort", CStr(g_nRelayPort))
        SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "UserName", g_strUserName)
    End Sub
End Module