' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Strict Off
Option Explicit On 

Imports SocketTools
Imports SocketTools.SocketWrench

Public Class UdpEcho
    Inherits System.Windows.Forms.Form

    Private WithEvents Socket As New SocketTools.SocketWrench

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        If Not Socket.Initialize() Then
            MsgBox("Unable to initialize SocketWrench component", MsgBoxStyle.Exclamation, "Error")
            End
        End If
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents TextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents ListBox1 As System.Windows.Forms.ListBox
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents TextBox3 As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.TextBox1 = New System.Windows.Forms.TextBox()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.TextBox2 = New System.Windows.Forms.TextBox()
        Me.ListBox1 = New System.Windows.Forms.ListBox()
        Me.Button1 = New System.Windows.Forms.Button()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.TextBox3 = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(16, 16)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(60, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Address:"
        '
        'TextBox1
        '
        Me.TextBox1.Location = New System.Drawing.Point(80, 14)
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.Size = New System.Drawing.Size(200, 20)
        Me.TextBox1.TabIndex = 1
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(300, 16)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(30, 16)
        Me.Label2.TabIndex = 2
        Me.Label2.Text = "Port:"
        '
        'TextBox2
        '
        Me.TextBox2.Location = New System.Drawing.Point(336, 14)
        Me.TextBox2.Name = "TextBox2"
        Me.TextBox2.Size = New System.Drawing.Size(40, 20)
        Me.TextBox2.TabIndex = 3
        '
        'ListBox1
        '
        Me.ListBox1.HorizontalScrollbar = True
        Me.ListBox1.Location = New System.Drawing.Point(16, 72)
        Me.ListBox1.Name = "ListBox1"
        Me.ListBox1.ScrollAlwaysVisible = True
        Me.ListBox1.Size = New System.Drawing.Size(360, 108)
        Me.ListBox1.TabIndex = 6
        Me.ListBox1.TabStop = False
        '
        'Button1
        '
        Me.Button1.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.Button1.Location = New System.Drawing.Point(152, 192)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(90, 30)
        Me.Button1.TabIndex = 7
        Me.Button1.Text = "Send"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(16, 42)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(56, 16)
        Me.Label3.TabIndex = 4
        Me.Label3.Text = "Message:"
        '
        'TextBox3
        '
        Me.TextBox3.Location = New System.Drawing.Point(80, 40)
        Me.TextBox3.Name = "TextBox3"
        Me.TextBox3.Size = New System.Drawing.Size(296, 20)
        Me.TextBox3.TabIndex = 5
        '
        'Form1
        '
        Me.AcceptButton = Me.Button1
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(394, 232)
        Me.Controls.Add(Me.TextBox3)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Button1)
        Me.Controls.Add(Me.ListBox1)
        Me.Controls.Add(Me.TextBox2)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.TextBox1)
        Me.Controls.Add(Me.Label1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MaximizeBox = False
        Me.Name = "Form1"
        Me.Text = "UDP Echo Example"
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Private Sub UpdateListBox(ByVal message As String)
        ListBox1.Items.Add(message)
        ListBox1.SelectedIndex = ListBox1.Items.Count - 1
        ListBox1.ClearSelected()
    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim strHostAddress As String
        Dim strMessage As String
        Dim nHostPort As Integer
        Dim nResult As Integer

        strHostAddress = TextBox1.Text.Trim()
        If strHostAddress.Length = 0 Then
            MsgBox("Please specify a valid IP address", MsgBoxStyle.Exclamation, "Error")
            Exit Sub
        End If

        nHostPort = Int32.Parse(TextBox2.Text)
        If nHostPort < 1 Or nHostPort > 65535 Then
            MsgBox("Please specify a valid port number", MsgBoxStyle.Exclamation, "Error")
            Exit Sub
        End If

        strMessage = TextBox3.Text.Trim()
        If strMessage.Length = 0 Then
            MsgBox("Please enter a message to send to the remote host", MsgBoxStyle.Exclamation, "Error")
            Exit Sub
        End If

        ' If the Handle property is -1, this means that a socket has not been created,
        ' probably because this is the first time the user has clicked the button.
        ' Initialize the socket properties and create a datagram socket using the Bind
        ' method. By setting Blocking to false, the OnRead event will be raised when
        ' the remote host echoes our message back to us.
        If Socket.Handle = -1 Then
            Socket.Protocol = SocketProtocol.socketDatagram
            Socket.Blocking = False

            ' Bind to any valid network interface and any available port number.
            If Not Socket.Bind("0.0.0.0", 0) Then
                MsgBox(Socket.LastErrorString, MsgBoxStyle.Exclamation, "Error")
                Exit Sub
            End If
        End If

        ' Use the WriteTo method to send our datagram to the specified address and
        ' port number; this method will return the number of bytes written or -1
        ' if an error occurs
        nResult = Socket.WriteTo(strMessage, strHostAddress, nHostPort)
        If nResult = -1 Then
            MsgBox(Socket.LastErrorString, MsgBoxStyle.Exclamation, "Error")
            Exit Sub
        End If

        UpdateListBox(String.Format("Sent {0} bytes of data to {1}:{2}", nResult, strHostAddress, nHostPort))
    End Sub

    Private Sub Socket_OnRead(ByVal sender As Object, ByVal e As System.EventArgs) Handles Socket.OnRead
        Dim strBuffer As String = String.Empty
        Dim strHostAddress As String = String.Empty
        Dim nHostPort As Integer = 0
        Dim nResult As Integer

        ' The OnRead event will fire whenever the remote host echoes back the datagram
        ' that we sent. The ReadFrom method will read the datagram, storing the contents
        ' in the specified buffer, along with the address and port number of the peer
        ' that sent the datagram.
        '
        ' Note that it's possible for ReadFrom to fail with errorConnectionReset,
        ' indicating that the address is valid but the port is unreachable.
        nResult = Socket.ReadFrom(strBuffer, 1024, strHostAddress, nHostPort)
        If nResult = -1 Then
            UpdateListBox(String.Format("Error {0}: {1}", Socket.LastError, Socket.LastErrorString))
            Exit Sub
        End If

        UpdateListBox(String.Format("Received {0} bytes of data from {1}:{2} [{3}]", nResult, strHostAddress, nHostPort, strBuffer))
    End Sub
End Class
