' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Strict Off
Option Explicit On

Public Class Form1

    Private SshClient1 As New SocketTools.SshClient

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not SshClient1.Initialize() Then
            MsgBox("Unable to initialize SocketTools component", MsgBoxStyle.Exclamation)
            End
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim strBuffer As String = String.Empty

        ' Initialize the class properties
        SshClient1.HostName = TextBox1.Text.Trim()
        SshClient1.RemotePort = Int32.Parse(TextBox2.Text)
        SshClient1.UserName = TextBox3.Text
        SshClient1.Password = TextBox4.Text
        SshClient1.Command = TextBox5.Text

        Button1.Enabled = False

        ' Attempt to connect to the server; if the connection fails,
        ' then display an error message
        If Not SshClient1.Connect() Then
            MsgBox(SshClient1.LastErrorString, MsgBoxStyle.Exclamation)
            Button1.Enabled = True
            Exit Sub
        End If

        ' Read the command output and append to the textbox control
        Do While SshClient1.ReadLine(strBuffer)
            TextBox6.AppendText(strBuffer + vbCrLf)
        Loop

        ' Disconnect from the server
        SshClient1.Disconnect()
        Button1.Enabled = True
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If SshClient1.IsConnected() Then
            SshClient1.Cancel()
        End If
        Me.Close()
    End Sub
End Class
