// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SocketTools;

namespace SecureShell1
{
    public partial class Form1 : Form
    {
        private SocketTools.SshClient sshClient;

        public Form1()
        {
            InitializeComponent();

            // Create an instance of the SocketTools.SshClient class
            sshClient = new SocketTools.SshClient();
            if (!sshClient.Initialize())
            {
                MessageBox.Show("Unable to initialize SocketTools component");
                Application.Exit();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string strBuffer = string.Empty;

            // Initialize the class properties with the values entered by the user
            sshClient.HostName = textBox1.Text.Trim();
            sshClient.RemotePort = Int32.Parse(textBox2.Text);
            sshClient.UserName = textBox3.Text;
            sshClient.Password = textBox4.Text;
            sshClient.Command = textBox5.Text;

            button1.Enabled = false;

            // Attempt to connect to the server; if the connection fails, then
            // display an error message
            if (!sshClient.Connect())
            {
                MessageBox.Show(sshClient.LastErrorString);
                button1.Enabled = true;
                return;
            }

            // Read each line of output from the server and append it to the
            // textbox control
            while (sshClient.ReadLine(ref strBuffer))
            {
                textBox6.AppendText(strBuffer + "\r\n");
            }

            // Disconnect from the server
            sshClient.Disconnect();
            button1.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (sshClient.IsConnected)
                sshClient.Cancel();

            this.Close();
        }
    }
}